(****************************************************************************
 * REGDEF.H                                                                 *
 *     Header file for Rage 128 Chapter 3 sample code                       *
 *     -all register offsets are expressed in bytes-                        *
 *                                                                          *
 * Copyright (c) 1999 ATI Technologies Inc.  All rights reserved.           *
 ****************************************************************************)

Unit RegDef; { (c)2000 Paul TOTH <tothpaul@free.fr> }

Interface

(****************************************************************************
 *                                                                          *
 *  RAGE128 REGISTER OFFSET CONSTANTS SECTION                               *
 *                                                                          *
 ****************************************************************************)
Const
(****************************************************************************
 *   VGA REGISTER CONSTANTS                                                 *
 ****************************************************************************)
 ioGENMO_WT                                 =$03c2;
 ioGENMO_RD                                 =$03cc;
 ioGENFC_RD                                 =$03ca;
 ioGENFC_WT                                 =$03ba;
 ioGENFC_WT_ALT1                            =$03da;
 ioGENS0                                    =$03c2;
 ioGENS1                                    =$03ba;
 ioGENS1_ALT1                               =$03da;
 ioGENENB                                   =$03c3;
 ioDAC_DATA                                 =$03c9;
 ioDAC_MASK                                 =$03c6;
 ioDAC_R_INDEX                              =$03c7;
 ioDAC_W_INDEX                              =$03c8;
 ioSEQ8_IDX                                 =$03c4;
 ioSEQ8_DATA                                =$03c5;
 ioCRTC8_IDX                                =$03b4;
 ioCRTC8_IDX_ALT1                           =$03d4;
 ioCRTC8_DATA                               =$03b5;
 ioCRTC8_DATA_ALT1                          =$03d5;
 ioGRPH8_IDX                                =$03ce;
 ioGRPH8_DATA                               =$03cf;
 ioATTRX                                    =$03c0;
 ioATTRDR                                   =$03c1;
 ioATTRDW                                   =$03c0;

(****************************************************************************
 *               NON-GUI Block I/O Mapped Registers                         *
 ****************************************************************************)
 ioMM_INDEX                                 =$0000;
 ioMM_DATA                                  =$0004;
 ioCLOCK_CNTL_INDEX                         =$0008;
 ioCLOCK_CNTL_DATA                          =$000c;
 ioBIOS_0_SCRATCH                           =$0010;
 ioBIOS_1_SCRATCH                           =$0014;
 ioBIOS_2_SCRATCH                           =$0018;
 ioBIOS_3_SCRATCH                           =$001c;
 ioBUS_CNTL                                 =$0030;
 ioMEM_VGA_WP_SEL                           =$0038;
 ioMEM_VGA_RP_SEL                           =$003c;
 ioGEN_INT_CNTL                             =$0040;
 ioGEN_INT_STATUS                           =$0044;
 ioCRTC_GEN_CNTL                            =$0050;
 ioCRTC_EXT_CNTL                            =$0054;
 ioDAC_CNTL                                 =$0058;
 ioCRTC_STATUS                              =$005c;
 ioPALETTE_INDEX                            =$00b0;
 ioPALETTE_DATA                             =$00b4;
 ioCONFIG_CNTL                              =$00e0;
 ioCONFIG_XSTRAP                            =$00e4;
 ioCONFIG_BONDS                             =$00e8;
 ioGEN_RESET_CNTL                           =$00f0;
 ioGEN_STATUS                               =$00f4;
 ioCONFIG_MEMSIZE                           =$00f8;


(****************************************************************************
 *               NON-GUI Block Memory Mapped Registers                      *
 ****************************************************************************)
 MM_INDEX                                   =$0000;
 MM_DATA                                    =$0004;
 CLOCK_CNTL_INDEX                           =$0008;
 CLOCK_CNTL_DATA                            =$000c;
 BIOS_0_SCRATCH                             =$0010;
 BIOS_1_SCRATCH                             =$0014;
 BIOS_2_SCRATCH                             =$0018;
 BIOS_3_SCRATCH                             =$001c;
 BUS_CNTL                                   =$0030;
 BUS_CNTL1                                  =$0034;
 MEM_VGA_WP_SEL                             =$0038;
 MEM_VGA_RP_SEL                             =$003c;
 GEN_INT_CNTL                               =$0040;
 GEN_INT_STATUS                             =$0044;
 CRTC_GEN_CNTL                              =$0050;
 CRTC_EXT_CNTL                              =$0054;
 DAC_CNTL                                   =$0058;
 CRTC_STATUS                                =$005c;
 GPIO_MONID                                 =$0068;
 I2C_CNTL_1                                 =$0094;
 PALETTE_INDEX                              =$00b0;
 PALETTE_DATA                               =$00b4;
 CONFIG_CNTL                                =$00e0;
 CONFIG_XSTRAP                              =$00e4;
 CONFIG_BONDS                               =$00e8;
 GEN_RESET_CNTL                             =$00f0;
 GEN_STATUS                                 =$00f4;
 CONFIG_MEMSIZE                             =$00f8;
 CONFIG_APER_0_BASE                         =$0100;
 CONFIG_APER_1_BASE                         =$0104;
 CONFIG_APER_SIZE                           =$0108;
 CONFIG_REG_1_BASE                          =$010c;
 CONFIG_REG_APER_SIZE                       =$0110;
 CONFIG_MEMSIZE_EMBEDDED                    =$0114;
 TEST_DEBUG_CNTL                            =$0120;
 TEST_DEBUG_MUX                             =$0124;
 HW_DEBUG                                   =$0128;
 TEST_DEBUG_OUT                             =$012c;
 HOST_PATH_CNTL                             =$0130;
 SW_SEMAPHORE                               =$013c;
 MEM_CNTL                                   =$0140;
 EXT_MEM_CNTL                               =$0144;
 MEM_ADDR_CONFIG                            =$0148;
 MEM_INTF_CNTL                              =$014c;
 MEM_STR_CNTL                               =$0150;
 MEM_INIT_LAT_TIMER                         =$0154;
 MEM_SDRAM_MODE_REG                         =$0158;
 AGP_BASE                                   =$0170;
 AGP_CNTL                                   =$0174;
 AGP_APER_OFFSET                            =$0178;
 PCI_GART_PAGE                              =$017c;
 PC_NGUI_MODE                               =$0180;
 PC_NGUI_CTLSTAT                            =$0184;
 VIDEOMUX_CNTL                              =$0190;
 MPP_TB_CONFIG                              =$01C0;
 MPP_GP_CONFIG                              =$01C8;
 VIPH_CONTROL                               =$01D0;
 CRTC_H_TOTAL_DISP                          =$0200;
 CRTC_H_SYNC_STRT_WID                       =$0204;
 CRTC_V_TOTAL_DISP                          =$0208;
 CRTC_V_SYNC_STRT_WID                       =$020c;
 CRTC_VLINE_CRNT_VLINE                      =$0210;
 CRTC_CRNT_FRAME                            =$0214;
 CRTC_GUI_TRIG_VLINE                        =$0218;
 CRTC_DEBUG                                 =$021c;
 CRTC_OFFSET                                =$0224;
 CRTC_OFFSET_CNTL                           =$0228;
 CRTC_PITCH                                 =$022c;
 OVR_CLR                                    =$0230;
 OVR_WID_LEFT_RIGHT                         =$0234;
 OVR_WID_TOP_BOTTOM                         =$0238;
 SNAPSHOT_VH_COUNTS                         =$0240;
 SNAPSHOT_F_COUNT                           =$0244;
 N_VIF_COUNT                                =$0248;
 SNAPSHOT_VIF_COUNT                         =$024c;
 CUR_OFFSET                                 =$0260;
 CUR_HORZ_VERT_POSN                         =$0264;
 CUR_HORZ_VERT_OFF                          =$0268;
 CUR_CLR0                                   =$026c;
 CUR_CLR1                                   =$0270;
 DAC_CRC_SIG                                =$02cc;
 DDA_CONFIG                                 =$02e0;
 DDA_ON_OFF                                 =$02e4;
 VGA_DDA_CONFIG                             =$02e8;
 VGA_DDA_ON_OFF                             =$02ec;
 OV0_Y_X_START                              =$0400;
 OV0_Y_X_END                                =$0404;
 OV0_EXCLUSIVE_HORZ                         =$0408;
 OV0_EXCLUSIVE_VERT                         =$040c;
 OV0_REG_LOAD_CNTL                          =$0410;
 OV0_SCALE_CNTL                             =$0420;
 OV0_V_INC                                  =$0424;
 OV0_P1_V_ACCUM_INIT                        =$0428;
 OV0_P23_V_ACCUM_INIT                       =$042c;
 OV0_P1_BLANK_LINES_AT_TOP                  =$0430;
 OV0_P23_BLANK_LINES_AT_TOP                 =$0434;
 OV0_VID_BUF0_BASE_ADRS                     =$0440;
 OV0_VID_BUF1_BASE_ADRS                     =$0444;
 OV0_VID_BUF2_BASE_ADRS                     =$0448;
 OV0_VID_BUF3_BASE_ADRS                     =$044c;
 OV0_VID_BUF4_BASE_ADRS                     =$0450;
 OV0_VID_BUF5_BASE_ADRS                     =$0454;
 OV0_VID_BUF_PITCH0_VALUE                   =$0460;
 OV0_VID_BUF_PITCH1_VALUE                   =$0464;
 OV0_OCTWORDS_PER_LINE_M1                   =$046c;
 OV0_AUTO_FLIP_CNTRL                        =$0470;
 OV0_DEINTERLACE_PATTERN                    =$0474;
 OV0_H_INC                                  =$0480;
 OV0_STEP_BY                                =$0484;
 OV0_P1_H_ACCUM_INIT                        =$0488;
 OV0_P23_H_ACCUM_INIT                       =$048c;
 OV0_P1_X_START_END                         =$0494;
 OV0_P2_X_START_END                         =$0498;
 OV0_P3_X_START_END                         =$049c;
 OV0_FILTER_CNTL                            =$04a0;
 OV0_FOUR_TAP_COEF_0                        =$04b0;
 OV0_FOUR_TAP_COEF_1                        =$04b4;
 OV0_FOUR_TAP_COEF_2                        =$04b8;
 OV0_FOUR_TAP_COEF_3                        =$04bc;
 OV0_FOUR_TAP_COEF_4                        =$04c0;
 OV0_COLOR_CNTL                             =$04e0;
 OV0_VIDEO_KEY_CLR                          =$04e4;
 OV0_VIDEO_KEY_MASK                         =$04e8;
 OV0_GRAPHICS_KEY_CLR                       =$04ec;
 OV0_GRAPHICS_KEY_MASK                      =$04f0;
 OV0_KEY_CNTL                               =$04f4;
 OV0_TEST                                   =$04f8;
 SUBPIC_CNTL                                =$0540;
 PM4_BUFFER_OFFSET                          =$0700;
 PM4_BUFFER_CNTL                            =$0704;
 PM4_BUFFER_WM_CNTL                         =$0708;
 PM4_BUFFER_DL_RPTR_ADDR                    =$070c;
 PM4_BUFFER_DL_RPTR                         =$0710;
 PM4_BUFFER_DL_WPTR                         =$0714;
 PM4_VC_FPU_SETUP                           =$071c;
 PM4_FPU_CNTL                               =$0720;
 PM4_VC_FORMAT                              =$0724;
 PM4_VC_CNTL                                =$0728;
 PM4_VC_I01                                 =$072c;
 PM4_VC_VLOFF                               =$0730;
 PM4_VC_VLSIZE                              =$0734;
 PM4_IW_INDOFF                              =$0738;
 PM4_IW_INDSIZE                             =$073c;
 PM4_FPU_FPX0                               =$0740;
 CRC_CMDFIFO_ADDR                           =$0740;
 PM4_FPU_FPY0                               =$0744;
 CRC_CMDFIFO_DOUT                           =$0744;
 PM4_FPU_FPX1                               =$0748;
 PM4_FPU_FPY1                               =$074c;
 PM4_FPU_FPX2                               =$0750;
 PM4_FPU_FPY2                               =$0754;
 PM4_FPU_FPY3                               =$0758;
 PM4_FPU_FPY4                               =$075c;
 PM4_FPU_FPY5                               =$0760;
 PM4_FPU_FPY6                               =$0764;
 PM4_FPU_FPR                                =$0768;
 PM4_FPU_FPG                                =$076c;
 PM4_FPU_FPB                                =$0770;
 PM4_FPU_FPA                                =$0774;
 PM4_FPU_INTXY0                             =$0780;
 PM4_FPU_INTXY1                             =$0784;
 PM4_FPU_INTXY2                             =$0788;
 PM4_FPU_INTARGB                            =$078c;
 PM4_FPU_FPTWICEAREA                        =$0790;
 PM4_FPU_DMAJOR01                           =$0794;
 PM4_FPU_DMAJOR12                           =$0798;
 PM4_FPU_DMAJOR02                           =$079c;
 PM4_FPU_STAT                               =$07a0;
 PM4_STAT                                   =$07b8;
 PM4_TEST_CNTL                              =$07d0;
 PM4_MICROCODE_ADDR                         =$07d4;
 PM4_MICROCODE_RADDR                        =$07d8;
 PM4_MICROCODE_DATAH                        =$07dc;
 PM4_MICROCODE_DATAL                        =$07e0;
 PM4_CMDFIFO_ADDR                           =$07e4;
 PM4_CMDFIFO_DATAH                          =$07e8;
 PM4_CMDFIFO_DATAL                          =$07ec;
 PM4_BUFFER_ADDR                            =$07f0;
 PM4_BUFFER_DATAH                           =$07f4;
 PM4_BUFFER_DATAL                           =$07f8;
 PM4_MICRO_CNTL                             =$07fc;
 VID_BUFFER_CONTROL                         =$0900;
 CAP_INT_CNTL                               =$0908;
 CAP_INT_STATUS                             =$090c;
 CAP0_BUF0_OFFSET                           =$0920;
 CAP0_BUF1_OFFSET                           =$0924;
 CAP0_BUF0_EVEN_OFFSET                      =$0928;
 CAP0_BUF1_EVEN_OFFSET                      =$092c;
 CAP0_BUF_PITCH                             =$0930;
 CAP0_V_WINDOW                              =$0934;
 CAP0_H_WINDOW                              =$0938;
 CAP0_VBI_ODD_OFFSET                        =$093c;
 CAP0_VBI_EVEN_OFFSET                       =$0940;
 CAP0_VBI_V_WINDOW                          =$0944;
 CAP0_VBI_H_WINDOW                          =$0948;
 CAP0_PORT_MODE_CNTL                        =$094c;
 CAP0_TRIG_CNTL                             =$0950;
 CAP0_DEBUG                                 =$0954;
 CAP0_CONFIG                                =$0958;
 CAP0_ANC_ODD_OFFSET                        =$095c;
 CAP0_ANC_EVEN_OFFSET                       =$0960;
 CAP0_ANC_H_WINDOW                          =$0964;
 CAP0_VIDEO_SYNC_TEST                       =$0968;
 CAP0_ONESHOT_BUF_OFFSET                    =$096c;
 CAP0_BUF_STATUS                            =$0970;
 CAP0_DWNSC_XRATIO                          =$0978;
 CAP0_XSHARPNESS                            =$097c;
 CAP1_BUF0_OFFSET                           =$0990;
 CAP1_BUF1_OFFSET                           =$0994;
 CAP1_BUF0_EVEN_OFFSET                      =$0998;
 CAP1_BUF1_EVEN_OFFSET                      =$099c;
 CAP1_BUF_PITCH                             =$09a0;
 CAP1_V_WINDOW                              =$09a4;
 CAP1_H_WINDOW                              =$09a8;
 CAP1_VBI_ODD_OFFSET                        =$09ac;
 CAP1_VBI_EVEN_OFFSET                       =$09b0;
 CAP1_VBI_V_WINDOW                          =$09b4;
 CAP1_VBI_H_WINDOW                          =$09b8;
 CAP1_PORT_MODE_CNTL                        =$09bc;
 CAP1_TRIG_CNTL                             =$09c0;
 CAP1_DEBUG                                 =$09c4;
 CAP1_CONFIG                                =$09c8;
 CAP1_ANC_ODD_OFFSET                        =$09cc;
 CAP1_ANC_EVEN_OFFSET                       =$09d0;
 CAP1_ANC_H_WINDOW                          =$09d4;
 CAP1_VIDEO_SYNC_TEST                       =$09d8;
 CAP1_ONESHOT_BUF_OFFSET                    =$09dc;
 CAP1_BUF_STATUS                            =$09e0;
 CAP1_DWNSC_XRATIO                          =$09e8;
 CAP1_XSHARPNESS                            =$09ec;
 BM_FRAME_BUF_OFFSET                        =$0a00;
 BM_SYSTEM_MEM_ADDR                         =$0a04;
 BM_COMMAND                                 =$0a08;
 BM_STATUS                                  =$0a0c;
 BM_QUEUE_STATUS                            =$0a10;
 BM_QUEUE_FREE_STATUS                       =$0A14;
 BM_CHUNK_0_VAL                             =$0a18;
 BM_CHUNK_1_VAL                             =$0a1C;
 BM_VIP0_BUF                                =$0A20;
 BM_VIP0_ACTIVE                             =$0A24;
 BM_VIP1_BUF                                =$0A30;
 BM_VIP1_ACTIVE                             =$0A34;
 BM_VIP2_BUF                                =$0A40;
 BM_VIP2_ACTIVE                             =$0A44;
 BM_VIP3_BUF                                =$0A50;
 BM_VIP3_ACTIVE                             =$0A54;
 BM_VIDCAP_BUF0                             =$0a60;
 BM_VIDCAP_BUF1                             =$0a64;
 BM_VIDCAP_BUF2                             =$0a68;
 BM_VIDCAP_ACTIVE                           =$0a6c;
 BM_GUI                                     =$0a80;
 SURFACE_DELAY                              =$0b00;

(****************************************************************************
 * PCI Config Space Alias Block Memory Mapped Registers (header only)       *
 ****************************************************************************)
 PCIHDR_VENDOR_ID                           =$0f00;
 PCIHDR_DEVICE_ID                           =$0f02;
 PCIHDR_COMMAND                             =$0f04;
 PCIHDR_STATUS                              =$0f06;
 PCIHDR_REVISION_ID                         =$0f08;
 PCIHDR_REGPROG_INF                         =$0f09;
 PCIHDR_SUB_CLASS                           =$0f0a;
 PCIHDR_BASE_CODE                           =$0f0b;
 PCIHDR_CACHE_LINE                          =$0f0c;
 PCIHDR_LATENCY                             =$0f0d;
 PCIHDR_HEADER                              =$0f0e;
 PCIHDR_BIST                                =$0f0f;
 PCIHDR_MEM_BASE                            =$0f10;
 PCIHDR_IO_BASE                             =$0f14;
 PCIHDR_REG_BASE                            =$0f18;
 PCIHDR_ADAPTER_ID                          =$0f2c;
 PCIHDR_BIOS_ROM                            =$0f30;
 PCIHDR_CAPABILITIES_PTR                    =$0f34;
 PCIHDR_INTERRUPT_LINE                      =$0f3c;
 PCIHDR_INTERRUPT_PIN                       =$0f3d;
 PCIHDR_MIN_GRANT                           =$0f3e;
 PCIHDR_MAX_LATENCY                         =$0f3f;
 PCIHDR_CAPABILITIES_ID                     =$0f50;
 PCIHDR_AGP_STATUS                          =$0f54;
 PCIHDR_AGP_COMMAND                         =$0f58;
 PCIHDR_PMI_REGISTER                        =$0f5c;
 PCIHDR_PWR_MNGMT_CNTL_STATUS               =$0f60;

(****************************************************************************
 *               NON-GUI PM4 FIFO DATA Registers                            *
 ****************************************************************************)
 PM4_FIFO_DATA_EVEN                         =$1000;
 PM4_FIFO_DATA_ODD                          =$1004;

(****************************************************************************
 *                  GUI Block Memory Mapped Registers                       *
 *                     These registers are FIFOed.                          *
 ****************************************************************************)
 DST_OFFSET                                 =$1404;
 DST_PITCH                                  =$1408;
 DST_WIDTH                                  =$140c;
 DST_HEIGHT                                 =$1410;
 SRC_X                                      =$1414;
 SRC_Y                                      =$1418;
 DST_X                                      =$141c;
 DST_Y                                      =$1420;
 SRC_PITCH_OFFSET                           =$1428;
 DST_PITCH_OFFSET                           =$142c;
 SRC_Y_X                                    =$1434;
 DST_Y_X                                    =$1438;
 DST_HEIGHT_WIDTH                           =$143c;
 DP_GUI_MASTER_CNTL                         =$146c;
 BRUSH_SCALE                                =$1470;
 BRUSH_Y_X                                  =$1474;
 DP_BRUSH_BKGD_CLR                          =$1478;
 DP_BRUSH_FRGD_CLR                          =$147c;
 BRUSH_DATA0                                =$1480;
 BRUSH_DATA1                                =$1484;
 BRUSH_DATA2                                =$1488;
 BRUSH_DATA3                                =$148c;
 BRUSH_DATA4                                =$1490;
 BRUSH_DATA5                                =$1494;
 BRUSH_DATA6                                =$1498;
 BRUSH_DATA7                                =$149c;
 BRUSH_DATA8                                =$14a0;
 BRUSH_DATA9                                =$14a4;
 BRUSH_DATA10                               =$14a8;
 BRUSH_DATA11                               =$14ac;
 BRUSH_DATA12                               =$14b0;
 BRUSH_DATA13                               =$14b4;
 BRUSH_DATA14                               =$14b8;
 BRUSH_DATA15                               =$14bc;
 BRUSH_DATA16                               =$14c0;
 BRUSH_DATA17                               =$14c4;
 BRUSH_DATA18                               =$14c8;
 BRUSH_DATA19                               =$14cc;
 BRUSH_DATA20                               =$14d0;
 BRUSH_DATA21                               =$14d4;
 BRUSH_DATA22                               =$14d8;
 BRUSH_DATA23                               =$14dc;
 BRUSH_DATA24                               =$14e0;
 BRUSH_DATA25                               =$14e4;
 BRUSH_DATA26                               =$14e8;
 BRUSH_DATA27                               =$14ec;
 BRUSH_DATA28                               =$14f0;
 BRUSH_DATA29                               =$14f4;
 BRUSH_DATA30                               =$14f8;
 BRUSH_DATA31                               =$14fc;
 BRUSH_DATA32                               =$1500;
 BRUSH_DATA33                               =$1504;
 BRUSH_DATA34                               =$1508;
 BRUSH_DATA35                               =$150c;
 BRUSH_DATA36                               =$1510;
 BRUSH_DATA37                               =$1514;
 BRUSH_DATA38                               =$1518;
 BRUSH_DATA39                               =$151c;
 BRUSH_DATA40                               =$1520;
 BRUSH_DATA41                               =$1524;
 BRUSH_DATA42                               =$1528;
 BRUSH_DATA43                               =$152c;
 BRUSH_DATA44                               =$1530;
 BRUSH_DATA45                               =$1534;
 BRUSH_DATA46                               =$1538;
 BRUSH_DATA47                               =$153c;
 BRUSH_DATA48                               =$1540;
 BRUSH_DATA49                               =$1544;
 BRUSH_DATA50                               =$1548;
 BRUSH_DATA51                               =$154c;
 BRUSH_DATA52                               =$1550;
 BRUSH_DATA53                               =$1554;
 BRUSH_DATA54                               =$1558;
 BRUSH_DATA55                               =$155c;
 BRUSH_DATA56                               =$1560;
 BRUSH_DATA57                               =$1564;
 BRUSH_DATA58                               =$1568;
 BRUSH_DATA59                               =$156c;
 BRUSH_DATA60                               =$1570;
 BRUSH_DATA61                               =$1574;
 BRUSH_DATA62                               =$1578;
 BRUSH_DATA63                               =$157c;
 DST_WIDTH_X                                =$1588;
 DST_HEIGHT_WIDTH_8                         =$158c;
 SRC_X_Y                                    =$1590;
 DST_X_Y                                    =$1594;
 DST_WIDTH_HEIGHT                           =$1598;
 DST_WIDTH_X_INCY                           =$159c;
 DST_HEIGHT_Y                               =$15a0;
 DST_X_SUB                                  =$15a4;
 DST_Y_SUB                                  =$15a8;
 SRC_OFFSET                                 =$15ac;
 SRC_PITCH                                  =$15b0;
 DST_HEIGHT_WIDTH_BW                        =$15b4;
 CLR_CMP_CNTL                               =$15c0;
 CLR_CMP_CLR_SRC                            =$15c4;
 CLR_CMP_CLR_DST                            =$15c8;
 CLR_CMP_MASK                               =$15cc;
 DP_SRC_FRGD_CLR                            =$15d8;
 DP_SRC_BKGD_CLR                            =$15dc;
 GUI_SCRATCH_REG0                           =$15e0;
 GUI_SCRATCH_REG1                           =$15e4;
 GUI_SCRATCH_REG2                           =$15e8;
 GUI_SCRATCH_REG3                           =$15ec;
 GUI_SCRATCH_REG4                           =$15f0;
 GUI_SCRATCH_REG5                           =$15f4;
 LEAD_BRES_ERR                              =$1600;
 LEAD_BRES_INC                              =$1604;
 LEAD_BRES_DEC                              =$1608;
 TRAIL_BRES_ERR                             =$160c;
 TRAIL_BRES_INC                             =$1610;
 TRAIL_BRES_DEC                             =$1614;
 TRAIL_X                                    =$1618;
 LEAD_BRES_LNTH                             =$161c;
 TRAIL_X_SUB                                =$1620;
 LEAD_BRES_LNTH_SUB                         =$1624;
 DST_BRES_ERR                               =$1628;
 DST_BRES_INC                               =$162c;
 DST_BRES_DEC                               =$1630;
 DST_BRES_LNTH                              =$1634;
 DST_BRES_LNTH_SUB                          =$1638;
 SC_LEFT                                    =$1640;
 SC_RIGHT                                   =$1644;
 SC_TOP                                     =$1648;
 SC_BOTTOM                                  =$164c;
 SRC_SC_RIGHT                               =$1654;
 SRC_SC_BOTTOM                              =$165c;
 AUX_SC_CNTL                                =$1660;
 AUX1_SC_LEFT                               =$1664;
 AUX1_SC_RIGHT                              =$1668;
 AUX1_SC_TOP                                =$166c;
 AUX1_SC_BOTTOM                             =$1670;
 AUX2_SC_LEFT                               =$1674;
 AUX2_SC_RIGHT                              =$1678;
 AUX2_SC_TOP                                =$167c;
 AUX2_SC_BOTTOM                             =$1680;
 AUX3_SC_LEFT                               =$1684;
 AUX3_SC_RIGHT                              =$1688;
 AUX3_SC_TOP                                =$168c;
 AUX3_SC_BOTTOM                             =$1690;
 GUI_DEBUG0                                 =$16a0;
 GUI_DEBUG1                                 =$16a4;
 GUI_TIMEOUT                                =$16b0;
 GUI_TIMEOUT0                               =$16b4;
 GUI_TIMEOUT1                               =$16b8;
 GUI_PROBE                                  =$16bc;
 DP_CNTL                                    =$16c0;
 DP_DATATYPE                                =$16c4;
 DP_MIX                                     =$16c8;
 DP_WRITE_MASK                              =$16cc;
 DP_CNTL_XDIR_YDIR_YMAJOR                   =$16d0;
 DEFAULT_OFFSET                             =$16e0;
 DEFAULT_PITCH                              =$16e4;
 DEFAULT_SC_BOTTOM_RIGHT                    =$16e8;
 SC_TOP_LEFT                                =$16ec;
 SC_BOTTOM_RIGHT                            =$16f0;
 SRC_SC_BOTTOM_RIGHT                        =$16f4;
 WAIT_UNTIL                                 =$1720;
 CACHE_CNTL                                 =$1724;
 GUI_STAT                                   =$1740;
 PC_GUI_MODE                                =$1744;
 PC_GUI_CTLSTAT                             =$1748;
 PC_DEBUG_MODE                              =$1760;
 BRES_DST_ERR_DEC                           =$1780;
 TRAIL_BRES_T12_ERR_DEC                     =$1784;
 TRAIL_BRES_T12_INC                         =$1788;
 DP_T12_CNTL                                =$178c;
 DST_BRES_T1_LNTH                           =$1790;
 DST_BRES_T2_LNTH                           =$1794;
 HOST_DATA0                                 =$17c0;
 HOST_DATA1                                 =$17c4;
 HOST_DATA2                                 =$17c8;
 HOST_DATA3                                 =$17cc;
 HOST_DATA4                                 =$17d0;
 HOST_DATA5                                 =$17d4;
 HOST_DATA6                                 =$17d8;
 HOST_DATA7                                 =$17dc;
 HOST_DATA_LAST                             =$17e0;
 FOG_3D_TABLE_START                         =$1810;
 FOG_3D_TABLE_END                           =$1814;
 FOG_3D_TABLE_DENSITY                       =$181c;
 SECONDARY_SCALE_PITCH                      =$1980;
 SECONDARY_SCALE_X_INC                      =$1984;
 SECONDARY_SCALE_Y_INC                      =$1988;
 SECONDARY_SCALE_HACC                       =$198c;
 SECONDARY_SCALE_VACC                       =$1990;
 SCALE_SRC_HEIGHT_WIDTH                     =$1994;
 SCALE_OFFSET_0                             =$1998;
 SCALE_PITCH                                =$199c;
 SCALE_X_INC                                =$19a0;
 SCALE_Y_INC                                =$19a4;
 SCALE_HACC                                 =$19a8;
 SCALE_VACC                                 =$19ac;
 SCALE_DST_X_Y                              =$19b0;
 SCALE_DST_HEIGHT_WIDTH                     =$19b4;
 SCALE_3D_CNTL                              =$1a00;
 FOG_TABLE_INDEX                            =$1a14;
 FOG_TABLE_DATA                             =$1a18;
 SCALE_3D_DATATYPE                          =$1a20;
 SETUP_CNTL                                 =$1bc4;
 SOLID_COLOR                                =$1bc8;
 WINDOW_XY_OFFSET                           =$1bcc;
 DRAW_LINE_POINT                            =$1bd0;
 SETUP_CNTL_PM4                             =$1bd4;
 DST_PITCH_OFFSET_C                         =$1c80;
 DP_GUI_MASTER_CNTL_C                       =$1c84;
 SC_TOP_LEFT_C                              =$1c88;
 SC_BOTTOM_RIGHT_C                          =$1c8c;

 Z_OFFSET_C                                 =$1c90;
 Z_PITCH_C                                  =$1c94;
 Z_STEN_CNTL_C                              =$1c98;
 TEX_CNTL_C                                 =$1c9c;
 MISC_3D_STATE_CNTL_REG                     =$1ca0;
 TEXTURE_CLR_CMP_CLR_C                      =$1CA4;
 TEXTURE_CLR_CMP_MSK_C                      =$1CA8;
 FOG_COLOR_C                                =$1CAC;
 PRIM_TEX_CNTL_C                            =$1CB0;
 PRIM_TEXTURE_COMBINE_CNTL_C                =$1CB4;
 TEX_SIZE_PITCH_C                           =$1CB8;
 PRIM_TEX_0_OFFSET_C                        =$1CBC;
 PRIM_TEX_1_OFFSET_C                        =$1CC0;
 PRIM_TEX_2_OFFSET_C                        =$1CC4;
 PRIM_TEX_3_OFFSET_C                        =$1CC8;
 PRIM_TEX_4_OFFSET_C                        =$1CCC;
 PRIM_TEX_5_OFFSET_C                        =$1CD0;
 PRIM_TEX_6_OFFSET_C                        =$1CD4;
 PRIM_TEX_7_OFFSET_C                        =$1CD8;
 PRIM_TEX_8_OFFSET_C                        =$1CDC;
 PRIM_TEX_9_OFFSET_C                        =$1CE0;
 PRIM_TEX_10_OFFSET_C                       =$1CE4;
 SEC_TEX_CNTL_C                             =$1D00;
 SEC_TEX_COMBINE_CNTL_C                     =$1D04;
 SEC_TEX_0_OFFSET_C                         =$1D08;
 SEC_TEX_1_OFFSET_C                         =$1D0C;
 SEC_TEX_2_OFFSET_C                         =$1D10;
 SEC_TEX_3_OFFSET_C                         =$1D14;
 SEC_TEX_4_OFFSET_C                         =$1D18;
 SEC_TEX_5_OFFSET_C                         =$1D1C;
 SEC_TEX_6_OFFSET_C                         =$1D20;
 SEC_TEX_7_OFFSET_C                         =$1D24;
 SEC_TEX_8_OFFSET_C                         =$1D28;
 SEC_TEX_9_OFFSET_C                         =$1D2C;
 SEC_TEX_10_OFFSET_C                        =$1D30;
 CONSTANT_COLOR_C                           =$1D34;
 PRIM_TEXTURE_BORDER_COLOR_C                =$1D38;
 SEC_TEXTURE_BORDER_COLOR_C                 =$1D3C;
 STEN_REF_MASK_C                            =$1D40;
 PLANE_3D_MASK_C                            =$1D44;

 CLR_CMP_MASK_3D                            =$1A28;
 MC_SRC1_CNTL                               =$19D8;
 TEX_CNTL                                   =$1800;
 CLR_CMP_CLR_3D                             =$1A24;

{ Digital Flat Panel }
 FP_CRTC_H_TOTAL_DISP                       =$0250;
 FP_CRTC_V_TOTAL_DISP                       =$0254;
 FP_GEN_CNTL                                =$0284;
 FP_PANEL_CNTL                              =$0288;
 FP_HORZ_STRETCH                            =$028C;
 FP_VERT_STRETCH                            =$0290;
 FP_H_SYNC_STRT_WID                         =$02C4;
 FP_V_SYNC_STRT_WID                         =$02C8;
 TMDS_CRC                                   =$02A0;

(****************************************************************************
 *                                                                          *
 *            RAGE128 INDIRECT REGISTER INDICES CONSTANTS SECTION           *
 *                                                                          *
 ****************************************************************************)

(****************************************************************************
 *                CLOCK_CNTL_INDEX Indexed Registers                        *
 ****************************************************************************)
 CLK_PIN_CNTL                               =$0001;
 PPLL_CNTL                                  =$0002;
 PPLL_REF_DIV                               =$0003;
 PPLL_DIV_0                                 =$0004;
 PPLL_DIV_1                                 =$0005;
 PPLL_DIV_2                                 =$0006;
 PPLL_DIV_3                                 =$0007;
 VCLK_ECP_CNTL                              =$0008;
 HTOTAL_CNTL                                =$0009;
 X_MPLL_REF_FB_DIV                          =$000a;
 XPLL_CNTL                                  =$000b;
 XDLL_CNTL                                  =$000c;
 XCLK_CNTL                                  =$000d;
 MPLL_CNTL                                  =$000e;
 MCLK_CNTL                                  =$000f;
 AGP_PLL_CNTL                               =$0010;
 FCP_CNTL                                   =$0012;
 PLL_TEST_CNTL                              =$0013;


(****************************************************************************
 *                                                                          *
 *               RAGE128 REGISTER MASK CONSTANTS SECTION                    *
 *                                                                          *
 ****************************************************************************)

(****************************************************************************
 *               RAGE128 Non-GUI Register Mask Constants                    *
 *  These are typically ORed together and are used with the register access *
 *  functions.                                                              *
 ****************************************************************************)

(* AGP_CNTL bit constants *)
 AGP_APER_SIZE_4M                           =$0000003f;
 AGP_APER_SIZE_8M                           =$0000003e;
 AGP_APER_SIZE_16M                          =$0000003c;
 AGP_APER_SIZE_32M                          =$00000038;
 AGP_APER_SIZE_64M                          =$00000030;
 AGP_APER_SIZE_128M                         =$00000020;
 AGP_APER_SIZE_256M                         =$00000000;
 AGP_HIGH_PRIORITY_READ                     =$00010000;
 AGP_TRDY_SET                               =$00020000;

(* BM_CHUNK_0_VAL bit constants *)
 BM_PTR_FORCE_TO_PCI                        =$00200000;
 BM_PM4_RD_FORCE_TO_PCI                     =$00400000;
 BM_GLOBAL_FORCE_TO_PCI                     =$00800000;
 BM_VIP3_NOCHUNK                            =$10000000;
 BM_VIP2_NOCHUNK                            =$20000000;
 BM_VIP1_NOCHUNK                            =$40000000;
 BM_VIP0_NOCHUNK                            =$80000000;

(* BM_COMMAND bit constants *)
 BM_INTERRUPT_DIS                           =$08000000;
 BM_TRANSFER_DEST_REG                       =$10000000;
 BM_FORCE_TO_PCI                            =$20000000;
 BM_FRAME_OFFSET_HOLD                       =$40000000;
 BM_END_OF_LIST                             =$80000000;

(* BM_QUEUE_STATUS bit constants *)
 BM_STATUS_VIP0_ACTIVE                      =$01000000;
 BM_STATUS_VIP1_ACTIVE                      =$02000000;
 BM_STATUS_VIP2_ACTIVE                      =$03000000;
 BM_STATUS_VIP3_ACTIVE                      =$04000000;
 BM_STATUS_GUI_ACTIVE                       =$40000000;
 BM_STATUS_VIDCAP_ACTIVE                    =$80000000;

(* BM_VIP?_BUF/VAPCAP/GUI bit constants *)
 BM_TRIG_SYS_TO_FRAME_IMM                   =$00000000;
 BM_TRIG_FRAME_TO_SYS_IMM                   =$00000001;

(* BUS_CNTL bit constants *)
 BUS_DBL_RESYNC                             =$00000001;
 BUS_MSTR_RESET                             =$00000002;
 BUS_FLUSH_BUF                              =$00000004;
 BUS_STOP_REQ_DIS                           =$00000008;
 BUS_ROTATION_DIS                           =$00000010;
 BUS_MASTER_DIS                             =$00000040;
 BUS_ROM_WRT_EN                             =$00000080;
 BUS_DIS_ROM                                =$00001000;
 BUS_PCI_READ_RETRY_EN                      =$00002000;
 BUS_AGP_AD_STEPPING_EN                     =$00004000;
 BUS_PCI_WRT_RETRY_EN                       =$00008000;
 BUS_MSTR_RD_MULT                           =$00100000;
 BUS_MSTR_RD_LINE                           =$00200000;
 BUS_SUSPEND                                =$00400000;
 LAT_16X                                    =$00800000;
 BUS_RD_DISCARD_EN                          =$01000000;
 BUS_RD_ABORT_EN                            =$02000000;
 BUS_MSTR_WS                                =$04000000;
 BUS_PARKING_DIS                            =$08000000;
 BUS_MSTR_DISCONNECT_EN                     =$10000000;
 BUS_WRT_BURST                              =$20000000;
 BUS_READ_BURST                             =$40000000;
 BUS_RDY_READ_DLY                           =$80000000;

(* CLOCK_CNTL_INDEX bit constants *)
 PLL_WR_EN                                  =$00000080;

(* CONFIG_CNTL bit constants *)
 CFG_VGA_RAM_EN                             =$00000100;

(* CRTC_EXT_CNTL bit constants *)
 VGA_ATI_LINEAR                             =$00000008;
 VGA_128KAP_PAGING                          =$00000010;

(* CRTC_GEN_CNTL bit constants *)
 CRTC_DBL_SCAN_EN                           =$00000001;
 CRTC_CUR_EN                                =$00010000;

(* CRTC_STATUS bit constants *)
 CRTC_VBLANK                                =$00000001;

(* CUR_OFFSET, CUR_HORZ_VERT_POSN, CUR_HORZ_VERT_OFF bit constants *)
 CUR_LOCK                                   =$80000000;

(* DAC_CNTL bit constants *)
 DAC_8BIT_EN                                =$00000100;
 DAC_4BPP_PIX_ORDER                         =$00000200;
 DAC_CRC_EN                                 =$00080000;

(* GEN_RESET_CNTL bit constants *)
 SOFT_RESET_GUI                             =$00000001;
 SOFT_RESET_VCLK                            =$00000100;
 SOFT_RESET_PCLK                            =$00000200;
 SOFT_RESET_ECP                             =$00000400;
 SOFT_RESET_DISPENG_XCLK                    =$00000800;

(* MEM_CNTL bit constants *)
 MEM_CTLR_STATUS_IDLE                       =$00000000;
 MEM_CTLR_STATUS_BUSY                       =$00100000;
 MEM_SEQNCR_STATUS_IDLE                     =$00000000;
 MEM_SEQNCR_STATUS_BUSY                     =$00200000;
 MEM_ARBITER_STATUS_IDLE                    =$00000000;
 MEM_ARBITER_STATUS_BUSY                    =$00400000;
 MEM_REQ_UNLOCK                             =$00000000;
 MEM_REQ_LOCK                               =$00800000;

(* MM_INDEX bit constants *)
 MM_APER                                    =$80000000;

(* PC_GUI_CTLSTAT bit constants *)
 PC_BUSY_INIT                               =$10000000;
 PC_BUSY_GUI                                =$20000000;
 PC_BUSY_NGUI                               =$40000000;
 PC_BUSY                                    =$80000000;

(* PCI_GART_BASE bit constants *)
 PCI_GART_DIS                               =$00000001;

(* PM4_BUFFER_CNTL bit constants *)
 PM4_BUFFER_CNTL_NOUPDATE                   =$08000000;
 PM4_BUFFER_CNTL_NONPM4                     =$00000000;
 PM4_BUFFER_CNTL_192PM4PIO                  =$10000000;
 PM4_BUFFER_CNTL_192PM4BM                   =$20000000;
 PM4_BUFFER_CNTL_128PM4PIO_64INDBM          =$30000000;
 PM4_BUFFER_CNTL_128PM4BM_64INDBM           =$40000000;
 PM4_BUFFER_CNTL_64PM4PIO_128INDBM          =$50000000;
 PM4_BUFFER_CNTL_64PM4BM_128INDBM           =$60000000;
 PM4_BUFFER_CNTL_64PM4PIO_64VERBM_64INDBM   =$70000000;
 PM4_BUFFER_CNTL_64PM4BM_64VERBM_64INDBM    =$80000000;
 PM4_BUFFER_CNTL_64PM4PIO_64VERPIO_64INDPIO =$f0000000;

(* PM4_BUFFER_DL_WPTR bit constants *)
 PM4_BUFFER_DL_DONE                         =$80000000;

(* PM4_MICRO_CNTL bit constants *)
 PM4_MICRO_FREERUN                          =$40000000;
 PM4_MICRO_STEP                             =$80000000;

(****************************************************************************
 *                                                                          *
 *                   RAGE128 GUI Register Mask Constants                    *
 *                                                                          *
 *      These are typically ORed together and are used with the register    *
 *      access functions.                                                   *
 *                                                                          *
 ****************************************************************************)

(* AUX_SC_CNTL bit constants *)
 AUX1_SC_EN                                 =$00000001;
 AUX1_SC_ADD                                =$00000000;
 AUX1_SC_SUBTRACT                           =$00000002;
 AUX2_SC_EN                                 =$00000004;
 AUX2_SC_ADD                                =$00000000;
 AUX2_SC_SUBTRACT                           =$00000008;
 AUX3_SC_EN                                 =$00000010;
 AUX3_SC_ADD                                =$00000000;
 AUX3_SC_SUBTRACT                           =$00000020;

(* CLR_CMP_CNTL bit constants *)
 COMPARE_SRC_FALSE                          =$00000000;
 COMPARE_SRC_TRUE                           =$00000001;
 COMPARE_SRC_NOT_EQUAL                      =$00000004;
 COMPARE_SRC_EQUAL                          =$00000005;
 COMPARE_SRC_EQUAL_FLIP                     =$00000007;
 COMPARE_DST_FALSE                          =$00000000;
 COMPARE_DST_TRUE                           =$00000100;
 COMPARE_DST_NOT_EQUAL                      =$00000400;
 COMPARE_DST_EQUAL                          =$00000500;
 COMPARE_DESTINATION                        =$00000000;
 COMPARE_SOURCE                             =$01000000;
 COMPARE_SRC_AND_DST                        =$02000000;

(* DP_CNTL bit constants *)
 DST_X_RIGHT_TO_LEFT                        =$00000000;
 DST_X_LEFT_TO_RIGHT                        =$00000001;
 DST_Y_BOTTOM_TO_TOP                        =$00000000;
 DST_Y_TOP_TO_BOTTOM                        =$00000002;
 DST_X_MAJOR                                =$00000000;
 DST_Y_MAJOR                                =$00000004;
 DST_X_TILE                                 =$00000008;
 DST_Y_TILE                                 =$00000010;
 DST_LAST_PEL                               =$00000020;
 DST_TRAIL_X_RIGHT_TO_LEFT                  =$00000000;
 DST_TRAIL_X_LEFT_TO_RIGHT                  =$00000040;
 DST_TRAP_FILL_RIGHT_TO_LEFT                =$00000000;
 DST_TRAP_FILL_LEFT_TO_RIGHT                =$00000080;
 DST_BRES_SIGN                              =$00000100;
 DST_HOST_BIG_ENDIAN_EN                     =$00000200;
 DST_POLYLINE_NONLAST                       =$00008000;
 DST_RASTER_STALL                           =$00010000;
 DST_POLY_EDGE                              =$00040000;

(* DP_CNTL_YDIR_XDIR_YMAJOR bit constants (short version of DP_CNTL) *)
 DST_X_MAJOR_S                              =$00000000;
 DST_Y_MAJOR_S                              =$00000001;
 DST_Y_BOTTOM_TO_TOP_S                      =$00000000;
 DST_Y_TOP_TO_BOTTOM_S                      =$00008000;
 DST_X_RIGHT_TO_LEFT_S                      =$00000000;
 DST_X_LEFT_TO_RIGHT_S                      =$80000000;

(* DP_DATATYPE bit constants *)
 DST_8BPP                                   =$00000002;
 DST_15BPP                                  =$00000003;
 DST_16BPP                                  =$00000004;
 DST_24BPP                                  =$00000005;
 DST_32BPP                                  =$00000006;

 DST_8BPP_RGB332                            =$00000007;
 DST_8BPP_Y8                                =$00000008;
 DST_8BPP_RGB8                              =$00000009;
 DST_16BPP_VYUY422                          =$0000000b;
 DST_16BPP_YVYU422                          =$0000000c;
 DST_32BPP_AYUV444                          =$0000000e;
 DST_16BPP_ARGB4444                         =$0000000f;

 BRUSH_8x8MONO                              =$00000000;
 BRUSH_8x8MONO_LBKGD                        =$00000100;
 BRUSH_8x1MONO                              =$00000200;
 BRUSH_8x1MONO_LBKGD                        =$00000300;
 BRUSH_1x8MONO                              =$00000400;
 BRUSH_1x8MONO_LBKGD                        =$00000500;
 BRUSH_32x1MONO                             =$00000600;
 BRUSH_32x1MONO_LBKGD                       =$00000700;
 BRUSH_32x32MONO                            =$00000800;
 BRUSH_32x32MONO_LBKGD                      =$00000900;
 BRUSH_8x8COLOR                             =$00000a00;
 BRUSH_8x1COLOR                             =$00000b00;
 BRUSH_1x8COLOR                             =$00000c00;
 BRUSH_SOLIDCOLOR                           =$00000d00;
 SRC_MONO                                   =$00000000;
 SRC_MONO_LBKGD                             =$00010000;
 SRC_DSTCOLOR                               =$00030000;
 BYTE_ORDER_MSB_TO_LSB                      =$00000000;
 BYTE_ORDER_LSB_TO_MSB                      =$40000000;
 DP_CONVERSION_TEMP                         =$80000000;

(* DP_GUI_MASTER_CNTL bit constants *)
 GMC_SRC_PITCH_OFFSET_DEFAULT               =$00000000;
 GMC_SRC_PITCH_OFFSET_LEAVE                 =$00000001;
 GMC_DST_PITCH_OFFSET_DEFAULT               =$00000000;
 GMC_DST_PITCH_OFFSET_LEAVE                 =$00000002;
 GMC_SRC_CLIP_DEFAULT                       =$00000000;
 GMC_SRC_CLIP_LEAVE                         =$00000004;
 GMC_DST_CLIP_DEFAULT                       =$00000000;
 GMC_DST_CLIP_LEAVE                         =$00000008;
 GMC_BRUSH_8x8MONO                          =$00000000;
 GMC_BRUSH_8x8MONO_LBKGD                    =$00000010;
 GMC_BRUSH_8x1MONO                          =$00000020;
 GMC_BRUSH_8x1MONO_LBKGD                    =$00000030;
 GMC_BRUSH_1x8MONO                          =$00000040;
 GMC_BRUSH_1x8MONO_LBKGD                    =$00000050;
 GMC_BRUSH_32x1MONO                         =$00000060;
 GMC_BRUSH_32x1MONO_LBKGD                   =$00000070;
 GMC_BRUSH_32x32MONO                        =$00000080;
 GMC_BRUSH_32x32MONO_LBKGD                  =$00000090;
 GMC_BRUSH_8x8COLOR                         =$000000a0;
 GMC_BRUSH_8x1COLOR                         =$000000b0;
 GMC_BRUSH_1x8COLOR                         =$000000c0;
 GMC_BRUSH_SOLIDCOLOR                       =$000000d0;
 GMC_DST_8BPP                               =$00000200;
 GMC_DST_15BPP                              =$00000300;
 GMC_DST_16BPP                              =$00000400;
 GMC_DST_24BPP                              =$00000500;
 GMC_DST_32BPP                              =$00000600;
 GMC_DST_8BPP_RGB332                        =$00000700;
 GMC_DST_8BPP_Y8                            =$00000800;
 GMC_DST_8BPP_RGB8                          =$00000900;
 GMC_DST_16BPP_VYUY422                      =$00000b00;
 GMC_DST_16BPP_YVYU422                      =$00000c00;
 GMC_DST_32BPP_AYUV444                      =$00000e00;
 GMC_DST_16BPP_ARGB4444                     =$00000f00;
 GMC_SRC_MONO                               =$00000000;
 GMC_SRC_MONO_LBKGD                         =$00001000;
 GMC_SRC_DSTCOLOR                           =$00003000;
 GMC_BYTE_ORDER_MSB_TO_LSB                  =$00000000;
 GMC_BYTE_ORDER_LSB_TO_MSB                  =$00004000;
 GMC_DP_CONVERSION_TEMP_9300                =$00008000;
 GMC_DP_CONVERSION_TEMP_6500                =$00000000;
 GMC_DP_SRC_RECT                            =$02000000;
 GMC_DP_SRC_HOST                            =$03000000;
 GMC_DP_SRC_HOST_BYTEALIGN                  =$04000000;
 GMC_3D_FCN_EN_CLR                          =$00000000;
 GMC_3D_FCN_EN_SET                          =$08000000;
 GMC_DST_CLR_CMP_FCN_LEAVE                  =$00000000;
 GMC_DST_CLR_CMP_FCN_CLEAR                  =$10000000;
 GMC_AUX_CLIP_LEAVE                         =$00000000;
 GMC_AUX_CLIP_CLEAR                         =$20000000;
 GMC_WRITE_MASK_LEAVE                       =$00000000;
 GMC_WRITE_MASK_SET                         =$40000000;

(* DP_MIX bit constants *)
 DP_SRC_RECT                                =$00000200;
 DP_SRC_HOST                                =$00000300;
 DP_SRC_HOST_BYTEALIGN                      =$00000400;

(****************************************************************************
 *                                                                          *
 *              DP_MIX and DP_GUI_MASTER_CNTL ROP3 RPN constants            *
 *                                                                          *
 *      P = pattern                                                         *
 *      S = source                                                          *
 *      D = destination                                                     *
 *      o = OR                                                              *
 *      a = AND                                                             *
 *      x = XOR                                                             *
 *      n = NOT                                                             *
 *                                                                          *
 ****************************************************************************)
 ROP3_ZERO                                  =$00000000;
 ROP3_DPSoon                                =$00010000;
 ROP3_DPSona                                =$00020000;
 ROP3_PSon                                  =$00030000;
 ROP3_SDPona                                =$00040000;
 ROP3_DPon                                  =$00050000;
 ROP3_PDSxnon                               =$00060000;
 ROP3_PDSaon                                =$00070000;
 ROP3_SDPnaa                                =$00080000;
 ROP3_PDSxon                                =$00090000;
 ROP3_DPna                                  =$000a0000;
 ROP3_PSDnaon                               =$000b0000;
 ROP3_SPna                                  =$000c0000;
 ROP3_PDSnaon                               =$000d0000;
 ROP3_PDSonon                               =$000e0000;
 ROP3_Pn                                    =$000f0000;
 ROP3_PDSona                                =$00100000;
 ROP3_DSon                                  =$00110000;
 ROP3_SDPxnon                               =$00120000;
 ROP3_SDPaon                                =$00130000;
 ROP3_DPSxnon                               =$00140000;
 ROP3_DPSaon                                =$00150000;
 ROP3_PSDPSanaxx                            =$00160000;
 ROP3_SSPxDSxaxn                            =$00170000;
 ROP3_SPxPDxa                               =$00180000;
 ROP3_SDPSanaxn                             =$00190000;
 ROP3_PDSPaox                               =$001a0000;
 ROP3_SDPSxaxn                              =$001b0000;
 ROP3_PSDPaox                               =$001c0000;
 ROP3_DSPDxaxn                              =$001d0000;
 ROP3_PDSox                                 =$001e0000;
 ROP3_PDSoan                                =$001f0000;
 ROP3_DPSnaa                                =$00200000;
 ROP3_SDPxon                                =$00210000;
 ROP3_DSna                                  =$00220000;
 ROP3_SPDnaon                               =$00230000;
 ROP3_SPxDSxa                               =$00240000;
 ROP3_PDSPanaxn                             =$00250000;
 ROP3_SDPSaox                               =$00260000;
 ROP3_SDPSxnox                              =$00270000;
 ROP3_DPSxa                                 =$00280000;
 ROP3_PSDPSaoxxn                            =$00290000;
 ROP3_DPSana                                =$002a0000;
 ROP3_SSPxPDxaxn                            =$002b0000;
 ROP3_SPDSoax                               =$002c0000;
 ROP3_PSDnox                                =$002d0000;
 ROP3_PSDPxox                               =$002e0000;
 ROP3_PSDnoan                               =$002f0000;
 ROP3_PSna                                  =$00300000;
 ROP3_SDPnaon                               =$00310000;
 ROP3_SDPSoox                               =$00320000;
 ROP3_Sn                                    =$00330000;
 ROP3_SPDSaox                               =$00340000;
 ROP3_SPDSxnox                              =$00350000;
 ROP3_SDPox                                 =$00360000;
 ROP3_SDPoan                                =$00370000;
 ROP3_PSDPoax                               =$00380000;
 ROP3_SPDnox                                =$00390000;
 ROP3_SPDSxox                               =$003a0000;
 ROP3_SPDnoan                               =$003b0000;
 ROP3_PSx                                   =$003c0000;
 ROP3_SPDSonox                              =$003d0000;
 ROP3_SPDSnaox                              =$003e0000;
 ROP3_PSan                                  =$003f0000;
 ROP3_PSDnaa                                =$00400000;
 ROP3_DPSxon                                =$00410000;
 ROP3_SDxPDxa                               =$00420000;
 ROP3_SPDSanaxn                             =$00430000;
 ROP3_SDna                                  =$00440000;
 ROP3_DPSnaon                               =$00450000;
 ROP3_DSPDaox                               =$00460000;
 ROP3_PSDPxaxn                              =$00470000;
 ROP3_SDPxa                                 =$00480000;
 ROP3_PDSPDaoxxn                            =$00490000;
 ROP3_DPSDoax                               =$004a0000;
 ROP3_PDSnox                                =$004b0000;
 ROP3_SDPana                                =$004c0000;
 ROP3_SSPxDSxoxn                            =$004d0000;
 ROP3_PDSPxox                               =$004e0000;
 ROP3_PDSnoan                               =$004f0000;
 ROP3_PDna                                  =$00500000;
 ROP3_DSPnaon                               =$00510000;
 ROP3_DPSDaox                               =$00520000;
 ROP3_SPDSxaxn                              =$00530000;
 ROP3_DPSonon                               =$00540000;
 ROP3_Dn                                    =$00550000;
 ROP3_DPSox                                 =$00560000;
 ROP3_DPSoan                                =$00570000;
 ROP3_PDSPoax                               =$00580000;
 ROP3_DPSnox                                =$00590000;
 ROP3_DPx                                   =$005a0000;
 ROP3_DPSDonox                              =$005b0000;
 ROP3_DPSDxox                               =$005c0000;
 ROP3_DPSnoan                               =$005d0000;
 ROP3_DPSDnaox                              =$005e0000;
 ROP3_DPan                                  =$005f0000;
 ROP3_PDSxa                                 =$00600000;
 ROP3_DSPDSaoxxn                            =$00610000;
 ROP3_DSPDoax                               =$00620000;
 ROP3_SDPnox                                =$00630000;
 ROP3_SDPSoax                               =$00640000;
 ROP3_DSPnox                                =$00650000;
 ROP3_DSx                                   =$00660000;
 ROP3_SDPSonox                              =$00670000;
 ROP3_DSPDSonoxxn                           =$00680000;
 ROP3_PDSxxn                                =$00690000;
 ROP3_DPSax                                 =$006a0000;
 ROP3_PSDPSoaxxn                            =$006b0000;
 ROP3_SDPax                                 =$006c0000;
 ROP3_PDSPDoaxxn                            =$006d0000;
 ROP3_SDPSnoax                              =$006e0000;
 ROP3_PDSxnan                               =$006f0000;
 ROP3_PDSana                                =$00700000;
 ROP3_SSDxPDxaxn                            =$00710000;
 ROP3_SDPSxox                               =$00720000;
 ROP3_SDPnoan                               =$00730000;
 ROP3_DSPDxox                               =$00740000;
 ROP3_DSPnoan                               =$00750000;
 ROP3_SDPSnaox                              =$00760000;
 ROP3_DSan                                  =$00770000;
 ROP3_PDSax                                 =$00780000;
 ROP3_DSPDSoaxxn                            =$00790000;
 ROP3_DPSDnoax                              =$007a0000;
 ROP3_SDPxnan                               =$007b0000;
 ROP3_SPDSnoax                              =$007c0000;
 ROP3_DPSxnan                               =$007d0000;
 ROP3_SPxDSxo                               =$007e0000;
 ROP3_DPSaan                                =$007f0000;
 ROP3_DPSaa                                 =$00800000;
 ROP3_SPxDSxon                              =$00810000;
 ROP3_DPSxna                                =$00820000;
 ROP3_SPDSnoaxn                             =$00830000;
 ROP3_SDPxna                                =$00840000;
 ROP3_PDSPnoaxn                             =$00850000;
 ROP3_DSPDSoaxx                             =$00860000;
 ROP3_PDSaxn                                =$00870000;
 ROP3_DSa                                   =$00880000;
 ROP3_SDPSnaoxn                             =$00890000;
 ROP3_DSPnoa                                =$008a0000;
 ROP3_DSPDxoxn                              =$008b0000;
 ROP3_SDPnoa                                =$008c0000;
 ROP3_SDPSxoxn                              =$008d0000;
 ROP3_SSDxPDxax                             =$008e0000;
 ROP3_PDSanan                               =$008f0000;
 ROP3_PDSxna                                =$00900000;
 ROP3_SDPSnoaxn                             =$00910000;
 ROP3_DPSDPoaxx                             =$00920000;
 ROP3_SPDaxn                                =$00930000;
 ROP3_PSDPSoaxx                             =$00940000;
 ROP3_DPSaxn                                =$00950000;
 ROP3_DPSxx                                 =$00960000;
 ROP3_PSDPSonoxx                            =$00970000;
 ROP3_SDPSonoxn                             =$00980000;
 ROP3_DSxn                                  =$00990000;
 ROP3_DPSnax                                =$009a0000;
 ROP3_SDPSoaxn                              =$009b0000;
 ROP3_SPDnax                                =$009c0000;
 ROP3_DSPDoaxn                              =$009d0000;
 ROP3_DSPDSaoxx                             =$009e0000;
 ROP3_PDSxan                                =$009f0000;
 ROP3_DPa                                   =$00a00000;
 ROP3_PDSPnaoxn                             =$00a10000;
 ROP3_DPSnoa                                =$00a20000;
 ROP3_DPSDxoxn                              =$00a30000;
 ROP3_PDSPonoxn                             =$00a40000;
 ROP3_PDxn                                  =$00a50000;
 ROP3_DSPnax                                =$00a60000;
 ROP3_PDSPoaxn                              =$00a70000;
 ROP3_DPSoa                                 =$00a80000;
 ROP3_DPSoxn                                =$00a90000;
 ROP3_D                                     =$00aa0000;
 ROP3_DPSono                                =$00ab0000;
 ROP3_SPDSxax                               =$00ac0000;
 ROP3_DPSDaoxn                              =$00ad0000;
 ROP3_DSPnao                                =$00ae0000;
 ROP3_DPno                                  =$00af0000;
 ROP3_PDSnoa                                =$00b00000;
 ROP3_PDSPxoxn                              =$00b10000;
 ROP3_SSPxDSxox                             =$00b20000;
 ROP3_SDPanan                               =$00b30000;
 ROP3_PSDnax                                =$00b40000;
 ROP3_DPSDoaxn                              =$00b50000;
 ROP3_DPSDPaoxx                             =$00b60000;
 ROP3_SDPxan                                =$00b70000;
 ROP3_PSDPxax                               =$00b80000;
 ROP3_DSPDaoxn                              =$00b90000;
 ROP3_DPSnao                                =$00ba0000;
 ROP3_DSno                                  =$00bb0000;
 ROP3_SPDSanax                              =$00bc0000;
 ROP3_SDxPDxan                              =$00bd0000;
 ROP3_DPSxo                                 =$00be0000;
 ROP3_DPSano                                =$00bf0000;
 ROP3_PSa                                   =$00c00000;
 ROP3_SPDSnaoxn                             =$00c10000;
 ROP3_SPDSonoxn                             =$00c20000;
 ROP3_PSxn                                  =$00c30000;
 ROP3_SPDnoa                                =$00c40000;
 ROP3_SPDSxoxn                              =$00c50000;
 ROP3_SDPnax                                =$00c60000;
 ROP3_PSDPoaxn                              =$00c70000;
 ROP3_SDPoa                                 =$00c80000;
 ROP3_SPDoxn                                =$00c90000;
 ROP3_DPSDxax                               =$00ca0000;
 ROP3_SPDSaoxn                              =$00cb0000;
 ROP3_S                                     =$00cc0000;
 ROP3_SDPono                                =$00cd0000;
 ROP3_SDPnao                                =$00ce0000;
 ROP3_SPno                                  =$00cf0000;
 ROP3_PSDnoa                                =$00d00000;
 ROP3_PSDPxoxn                              =$00d10000;
 ROP3_PDSnax                                =$00d20000;
 ROP3_SPDSoaxn                              =$00d30000;
 ROP3_SSPxPDxax                             =$00d40000;
 ROP3_DPSanan                               =$00d50000;
 ROP3_PSDPSaoxx                             =$00d60000;
 ROP3_DPSxan                                =$00d70000;
 ROP3_PDSPxax                               =$00d80000;
 ROP3_SDPSaoxn                              =$00d90000;
 ROP3_DPSDanax                              =$00da0000;
 ROP3_SPxDSxan                              =$00db0000;
 ROP3_SPDnao                                =$00dc0000;
 ROP3_SDno                                  =$00dd0000;
 ROP3_SDPxo                                 =$00de0000;
 ROP3_SDPano                                =$00df0000;
 ROP3_PDSoa                                 =$00e00000;
 ROP3_PDSoxn                                =$00e10000;
 ROP3_DSPDxax                               =$00e20000;
 ROP3_PSDPaoxn                              =$00e30000;
 ROP3_SDPSxax                               =$00e40000;
 ROP3_PDSPaoxn                              =$00e50000;
 ROP3_SDPSanax                              =$00e60000;
 ROP3_SPxPDxan                              =$00e70000;
 ROP3_SSPxDSxax                             =$00e80000;
 ROP3_DSPDSanaxxn                           =$00e90000;
 ROP3_DPSao                                 =$00ea0000;
 ROP3_DPSxno                                =$00eb0000;
 ROP3_SDPao                                 =$00ec0000;
 ROP3_SDPxno                                =$00ed0000;
 ROP3_DSo                                   =$00ee0000;
 ROP3_SDPnoo                                =$00ef0000;
 ROP3_P                                     =$00f00000;
 ROP3_PDSono                                =$00f10000;
 ROP3_PDSnao                                =$00f20000;
 ROP3_PSno                                  =$00f30000;
 ROP3_PSDnao                                =$00f40000;
 ROP3_PDno                                  =$00f50000;
 ROP3_PDSxo                                 =$00f60000;
 ROP3_PDSano                                =$00f70000;
 ROP3_PDSao                                 =$00f80000;
 ROP3_PDSxno                                =$00f90000;
 ROP3_DPo                                   =$00fa0000;
 ROP3_DPSnoo                                =$00fb0000;
 ROP3_PSo                                   =$00fc0000;
 ROP3_PSDnoo                                =$00fd0000;
 ROP3_DPSoo                                 =$00fe0000;
 ROP3_ONE                                   =$00ff0000;

(****************************************************************************
 *              DP_MIX, DP_GUI_MASTER_CNTL ROP3 named constants             *
 *                                                                          *
 *                  Pattern (P):     1 1 1 1 0 0 0 0                        *
 *                  Source  (S):     1 1 0 0 1 1 0 0                        *
 *                  Destination (D): 1 0 1 0 1 0 1 0                        *
 *                                                                          *
 ****************************************************************************)
 ROP3_BLACKNESS                             =$00000000;   { 0          }
 ROP3_NOTSRCERASE                           =$00110000;   { ~(S | D)   }
 ROP3_NOTSRCCOPY                            =$00330000;   { ~S         }
 ROP3_SRCERASE                              =$00440000;   { S & ~D     }
 ROP3_DSTINVERT                             =$00550000;   { ~D         }
 ROP3_PATINVERT                             =$005a0000;   { P ^ D      }
 ROP3_SRCINVERT                             =$00660000;   { S ^ D      }
 ROP3_SRCAND                                =$00880000;   { S & D      }
 ROP3_DSTCOPY                               =$00aa0000;   { D          }
 ROP3_MERGEPAINT                            =$00bb0000;   { ~S | D     }
 ROP3_MERGECOPY                             =$00c00000;   { P & S      }
 ROP3_SRCCOPY                               =$00cc0000;   { S          }
 ROP3_SRCPAINT                              =$00ee0000;   { S | D      }
 ROP3_PATCOPY                               =$00f00000;   { P          }
 ROP3_PATPAINT                              =$00fb0000;   { P | ~S | D }
 ROP3_WHITENESS                             =$00ff0000;   { 1          }

(****************************************************************************
 *               GUI_STAT and PM4_STAT common bit constants                 *
 ****************************************************************************)
 PM4_BUSY                                   =$00010000;
 MICRO_BUSY                                 =$00020000;
 FPU_BUSY                                   =$00040000;
 VC_BUSY                                    =$00080000;
 IDCT_BUSY                                  =$00100000;
 ENG_EV_BUSY                                =$00200000;
 SETUP_BUSY                                 =$00400000;
 EDGEWALK_BUSY                              =$00800000;
 ENG_3D_BUSY                                =$01000000;
 ENG_2D_SM_BUSY                             =$02000000;
 ENG_2D_BUSY                                =$04000000;
 GUI_WB_BUSY                                =$08000000;
 CACHE_BUSY                                 =$10000000;
 GUI_ACTIVE                                 =$80000000;

(****************************************************************************
 *                      SCALE_3D_CNTL bit constants                         *
 ****************************************************************************)
 SCALE_DITHER                               =$00000002;
 TEX_CACHE_SIZE                             =$00000004;
 DITHER_INIT                                =$00000008;
 ROUND_EN                                   =$00000010;
 TEX_CACHE_DIS                              =$00000020;
 SCALE_3D_FCN_NOOP                          =$00000000;
 SCALE_3D_FCN_SCALING                       =$00000040;
 SCALE_3D_FCN_TEXTURE_SHADE                 =$00000080;
 SCALE_PIX_REP                              =$00000100;

(****************************************************************************
 *                  SCALE_3D_DATATYPE bit constants                         *
 ****************************************************************************)
 PRIMARY_2BPP                               =$00000000;
 PRIMARY_4BPP                               =$00000001;
 PRIMARY_8BPP                               =$00000002;
 PRIMARY_15BPP                              =$00000003;
 PRIMARY_16BPP                              =$00000004;
 PRIMARY_32BPP                              =$00000006;
 PRIMARY_8BPP_RGB332                        =$00000007;
 PRIMARY_8BPP_Y8                            =$00000008;
 PRIMARY_8BPP_RGB8                          =$00000009;
 PRIMARY_16BPP_P88                          =$0000000a;
 PRIMARY_16BPP_VYUY422                      =$0000000b;
 PRIMARY_16BPP_YVYU422                      =$0000000c;
 PRIMARY_16BPP_RGB8_P88                     =$0000000d;
 PRIMARY_32BPP_AYUV444                      =$0000000e;
 PRIMARY_16BPP_ARGB4444                     =$0000000f;
 PRIMARY_PALETTE_OFF_EITHER                 =$00000000;
 PRIMARY_PALETTE_OFF_1                      =$00000010;
 PRIMARY_PALETTE_OFF_2                      =$00000020;
 PRIMARY_CI_RGB565                          =$00000000;
 PRIMARY_CI_ARGB1555                        =$00000100;
 PRIMARY_CI_ARGB4444                        =$00000200;

(****************************************************************************
 *                          SCALE_PITCH bit constants                       *
 ****************************************************************************)
 SCALE_TILE                                 =$00010000;
 SCALE_PITCH_ADJ_NONE                       =$00000000;
 SCALE_PITCH_ADJ_2                          =$40000000;
 SCALE_PITCH_ADJ_4                          =$80000000;

(****************************************************************************
 *                          3D context registers                            *
 ****************************************************************************)
(* MISC_3D_STATE bit constants *)
 MISC_3D_STATE_SCALE_3D_FN_NOP                    =($00000000 shl 8);
 MISC_3D_STATE_SCALE_3D_FN_SCALE                  =($00000001 shl 8);
 MISC_3D_STATE_SCALE_3D_FN_TMAP_SHADE             =($00000002 shl 8);
 MISC_3D_STATE_SCALE_PIX_REP_BLEND                =($00000000 shl 10);
 MISC_3D_STATE_SCALE_PIX_REP_REPLICATE            =($00000001 shl 10);
 MISC_3D_STATE_ALPHA_COMB_FNC_ADD_CLAMP           =($00000000 shl 12);
 MISC_3D_STATE_ALPHA_COMB_FNC_ADD_NO_CLAMP	  =($00000001 shl 12);
 MISC_3D_STATE_ALPHA_COMB_FNC_SUB_SRC_DST_CLAMP	  =($00000002 shl 12);
 MISC_3D_STATE_ALPHA_COMB_FNC_SUB_SRC_DST_NO_CLAMP=($00000003 shl 12);
 MISC_3D_STATE_FOG_TABLE_EN_VERTEX_FOG	          =($00000000 shl 14);
 MISC_3D_STATE_FOG_TABLE_EN_TABLE_FOG	          =($00000001 shl 14);
 MISC_3D_STATE_ALPHA_BLEND_SRC_ZERO               =($00000000 shl 16);
 MISC_3D_STATE_ALPHA_BLEND_SRC_ONE                =($00000001 shl 16);
 MISC_3D_STATE_ALPHA_BLEND_SRC_SRCCOLOR	          =($00000002 shl 16);
 MISC_3D_STATE_ALPHA_BLEND_SRC_INVSRCCOLOR	  =($00000003 shl 16);
 MISC_3D_STATE_ALPHA_BLEND_SRC_SRCALPHA	          =($00000004 shl 16);
 MISC_3D_STATE_ALPHA_BLEND_SRC_INVSRCALPHA	  =($00000005 shl 16);
 MISC_3D_STATE_ALPHA_BLEND_SRC_DESTALPHA	  =($00000006 shl 16);
 MISC_3D_STATE_ALPHA_BLEND_SRC_INVDESTALPHA	  =($00000007 shl 16);
 MISC_3D_STATE_ALPHA_BLEND_SRC_DESTCOLOR	  =($00000008 shl 16);
 MISC_3D_STATE_ALPHA_BLEND_SRC_INVDESTCOLOR	  =($00000009 shl 16);
 MISC_3D_STATE_ALPHA_BLEND_SRC_SRCALPHASAT	  =($0000000a shl 16);
 MISC_3D_STATE_ALPHA_BLEND_SRC_BOTHSRCALPHA	  =($0000000b shl 16);
 MISC_3D_STATE_ALPHA_BLEND_SRC_BOTHINVSRCALPHA	  =($0000000c shl 16);
 MISC_3D_STATE_ALPHA_BLEND_DST_ZERO	          =($00000000 shl 20);
 MISC_3D_STATE_ALPHA_BLEND_DST_ONE	          =($00000001 shl 20);
 MISC_3D_STATE_ALPHA_BLEND_DST_SRCCOLOR	          =($00000002 shl 20);
 MISC_3D_STATE_ALPHA_BLEND_DST_INVSRCCOLOR	  =($00000003 shl 20);
 MISC_3D_STATE_ALPHA_BLEND_DST_SRCALPHA	          =($00000004 shl 20);
 MISC_3D_STATE_ALPHA_BLEND_DST_INVSRCALPHA	  =($00000005 shl 20);
 MISC_3D_STATE_ALPHA_BLEND_DST_DESTALPHA	  =($00000006 shl 20);
 MISC_3D_STATE_ALPHA_BLEND_DST_INVDESTALPHA	  =($00000007 shl 20);
 MISC_3D_STATE_ALPHA_BLEND_DST_DESTCOLOR	  =($00000008 shl 20);
 MISC_3D_STATE_ALPHA_BLEND_DST_INVDESTCOLOR	  =($00000009 shl 20);
 MISC_3D_STATE_ALPHA_BLEND_DST_SRCALPHASAT	  =($0000000a shl 20);
 MISC_3D_STATE_ALPHA_TEST_OP_NEVER	          =($00000000 shl 24);
 MISC_3D_STATE_ALPHA_TEST_OP_LESS	          =($00000001 shl 24);
 MISC_3D_STATE_ALPHA_TEST_OP_LESSEQUAL	          =($00000002 shl 24);
 MISC_3D_STATE_ALPHA_TEST_OP_EQUAL	          =($00000003 shl 24);
 MISC_3D_STATE_ALPHA_TEST_OP_GREATEREQUAL	  =($00000004 shl 24);
 MISC_3D_STATE_ALPHA_TEST_OP_GREATER	          =($00000005 shl 24);
 MISC_3D_STATE_ALPHA_TEST_OP_NEQUAL	          =($00000006 shl 24);
 MISC_3D_STATE_ALPHA_TEST_OP_ALWAYS	          =($00000007 shl 24);

(* Z_STEN_CNTL bit constants *)
 Z_STEN_CNTL_Z_PIX_WIDTH_16             =($00000000 shl 1);
 Z_STEN_CNTL_Z_PIX_WIDTH_24             =($00000001 shl 1);
 Z_STEN_CNTL_Z_PIX_WIDTH_32             =($00000002 shl 1);
 Z_STEN_CNTL_Z_TEST_NEVER               =($00000000 shl 4);
 Z_STEN_CNTL_Z_TEST_LESS                =($00000001 shl 4);
 Z_STEN_CNTL_Z_TEST_LESSEQUAL           =($00000002 shl 4);
 Z_STEN_CNTL_Z_TEST_EQUAL               =($00000003 shl 4);
 Z_STEN_CNTL_Z_TEST_GREATEREQUAL        =($00000004 shl 4);
 Z_STEN_CNTL_Z_TEST_GREATER             =($00000005 shl 4);
 Z_STEN_CNTL_Z_TEST_NEQUAL              =($00000006 shl 4);
 Z_STEN_CNTL_Z_TEST_ALWAYS              =($00000007 shl 4);
 Z_STEN_CNTL_STENCIL_TEST_NEVER         =($00000000 shl 12);
 Z_STEN_CNTL_STENCIL_TEST_LESS          =($00000001 shl 12);
 Z_STEN_CNTL_STENCIL_TEST_LESSEQUAL     =($00000002 shl 12);
 Z_STEN_CNTL_STENCIL_TEST_EQUAL         =($00000003 shl 12);
 Z_STEN_CNTL_STENCIL_TEST_GREATEREQUAL  =($00000004 shl 12);
 Z_STEN_CNTL_STENCIL_TEST_GREATER       =($00000005 shl 12);
 Z_STEN_CNTL_STENCIL_TEST_NEQUAL        =($00000006 shl 12);
 Z_STEN_CNTL_STENCIL_TEST_ALWAYS        =($00000007 shl 12);
 Z_STEN_CNTL_STENCIL_S_FAIL_OP_KEEP     =($00000000 shl 16);
 Z_STEN_CNTL_STENCIL_S_FAIL_OP_ZERO     =($00000001 shl 16);
 Z_STEN_CNTL_STENCIL_S_FAIL_OP_REPLACE  =($00000002 shl 16);
 Z_STEN_CNTL_STENCIL_S_FAIL_OP_INC      =($00000003 shl 16);
 Z_STEN_CNTL_STENCIL_S_FAIL_OP_DEC      =($00000004 shl 16);
 Z_STEN_CNTL_STENCIL_S_FAIL_OP_INV      =($00000005 shl 16);
 Z_STEN_CNTL_STENCIL_ZPASS_OP_KEEP      =($00000000 shl 20);
 Z_STEN_CNTL_STENCIL_ZPASS_OP_ZERO      =($00000001 shl 20);
 Z_STEN_CNTL_STENCIL_ZPASS_OP_REPLACE   =($00000002 shl 20);
 Z_STEN_CNTL_STENCIL_ZPASS_OP_INC       =($00000003 shl 20);
 Z_STEN_CNTL_STENCIL_ZPASS_OP_DEC       =($00000004 shl 20);
 Z_STEN_CNTL_STENCIL_ZPASS_OP_INV       =($00000005 shl 20);
 Z_STEN_CNTL_STENCIL_ZFAIL_OP_KEEP      =($00000000 shl 24);
 Z_STEN_CNTL_STENCIL_ZFAIL_OP_ZERO      =($00000001 shl 24);
 Z_STEN_CNTL_STENCIL_ZFAIL_OP_REPLACE   =($00000002 shl 24);
 Z_STEN_CNTL_STENCIL_ZFAIL_OP_INC       =($00000003 shl 24);
 Z_STEN_CNTL_STENCIL_ZFAIL_OP_DEC       =($00000004 shl 24);
 Z_STEN_CNTL_STENCIL_ZFAIL_OP_INV       =($00000005 shl 24);

(* TEX_CNTL bit constants *)
 TEX_CNTL_Z_EN_OFF                   =($00000000 shl 0);
 TEX_CNTL_Z_EN_ON                    =($00000001 shl 0);
 TEX_CNTL_Z_MASK_DIS                 =($00000000 shl 1);
 TEX_CNTL_Z_MASK_EN                  =($00000001 shl 1);
 TEX_CNTL_STENCIL_EN_OFF             =($00000000 shl 3);
 TEX_CNTL_STENCIL_EN_ON              =($00000001 shl 3);
 TEX_CNTL_TEX_EN_SHADE               =($00000000 shl 4);
 TEX_CNTL_TEX_EN_TMAP                =($00000001 shl 4);
 TEX_CNTL_SECONDARY_TEX_EN_OFF       =($00000000 shl 5);
 TEX_CNTL_SECONDARY_TEX_EN_ON        =($00000001 shl 5);
 TEX_CNTL_FOG_EN_OFF                 =($00000000 shl 7);
 TEX_CNTL_FOG_EN_ON                  =($00000001 shl 7);
 TEX_CNTL_DITHRE_EN_OFF              =($00000000 shl 8);
 TEX_CNTL_DITHRE_EN_ON               =($00000001 shl 8);
 TEX_CNTL_ALPHA_EN_OFF               =($00000000 shl 9);
 TEX_CNTL_ALPHA_EN_ON                =($00000001 shl 9);
 TEX_CNTL_ALPHA_TEST_EN_OFF          =($00000000 shl 10);
 TEX_CNTL_ALPHA_TEST_EN_ON           =($00000001 shl 10);
 TEX_CNTL_SPEC_LIGHT_EN_OFF          =($00000000 shl 11);
 TEX_CNTL_SPEC_LIGHT_EN_ON           =($00000001 shl 11);
 TEX_CNTL_TEX_CHROMA_KEY_EN_OFF      =($00000000 shl 12);
 TEX_CNTL_TEX_CHROMA_KEY_EN_ON       =($00000001 shl 12);
 TEX_CNTL_AMASK_EN_OFF               =($00000000 shl 13);
 TEX_CNTL_AMASK_EN_ON                =($00000001 shl 13);
 TEX_CNTL_LIGHT_FN_DIS               =($00000000 shl 14);
 TEX_CNTL_LIGHT_FN_COPY              =($00000001 shl 14);
 TEX_CNTL_LIGHT_FN_MODULATE          =($00000002 shl 14);
 TEX_CNTL_LIGHT_FN_ADD               =($00000003 shl 14);
 TEX_CNTL_LIGHT_FN_BLEND_CONSTANT    =($00000004 shl 14);
 TEX_CNTL_LIGHT_FN_BLEND_TEXTURE     =($00000005 shl 14);
 TEX_CNTL_LIGHT_FN_BLEND_VERTEX      =($00000006 shl 14);
 TEX_CNTL_LIGHT_FN_BLEND_CONST_COLOR =($00000007 shl 14);
 TEX_CNTL_ALPHA_LIGHT_FN_DIS         =($00000000 shl 18);
 TEX_CNTL_ALPHA_LIGHT_FN_COPY        =($00000001 shl 18);
 TEX_CNTL_ALPHA_LIGHT_FN_MODULATE    =($00000002 shl 18);
 TEX_CNTL_ALPHA_LIGHT_FN_ADD         =($00000003 shl 18);
{ TEX_CNTL_ANTI_ALIAS_FN }
 TEX_CNTL_TEX_CACHE_FLUSH_OFF        =($00000000 shl 23);
 TEX_CNTL_TEX_CACHE_FLUSH_ON         =($00000001 shl 23);
{ TEX_CNTL_LOD_BIAS }

(* PRIM_TEX_CNTL bit constants *)
 PRIM_TEX_CNTL_PRIM_MIN_BLEND_FN_NEAREST=($00000000 shl 0);
 PRIM_TEX_CNTL_PRIM_MIN_BLEND_FN_LINEAR=($00000001 shl 0);
 PRIM_TEX_CNTL_PRIM_MIN_BLEND_FN_MIPNEAREST=($00000002 shl 0);
 PRIM_TEX_CNTL_PRIM_MIN_BLEND_FN_MIPLINEAR=($00000003 shl 0);
 PRIM_TEX_CNTL_PRIM_MIN_BLEND_FN_LINEARMIPNEAREST=($00000004 shl 0);
 PRIM_TEX_CNTL_PRIM_MIN_BLEND_FN_LINEARMIPLINEAR=($00000005 shl 0);
 PRIM_TEX_CNTL_PRIM_MAG_BLEND_FN_NEAREST=($00000000 shl 4);
 PRIM_TEX_CNTL_PRIM_MAG_BLEND_FN_LINEAR=($00000001 shl 4);
 PRIM_TEX_CNTL_MIP_MAP_DIS_OFF=($00000000 shl 7);
 PRIM_TEX_CNTL_MIP_MAP_DIS_ON=($00000001 shl 7);
 PRIM_TEX_CNTL_PRIM_TEX_CLAMP_MODE_S_WRAP=($00000000 shl 8);
 PRIM_TEX_CNTL_PRIM_TEX_CLAMP_MODE_S_MIRROR=($00000001 shl 8);
 PRIM_TEX_CNTL_PRIM_TEX_CLAMP_MODE_S_CLAMP=($00000002 shl 8);
 PRIM_TEX_CNTL_PRIM_TEX_CLAMP_MODE_S_BORDER_COLOR=($00000003 shl 8);
 PRIM_TEX_CNTL_PRIM_TEX_WRAP_S_OFF=($00000000 shl 10);
 PRIM_TEX_CNTL_PRIM_TEX_WRAP_S_ON=($00000001 shl 10);
 PRIM_TEX_CNTL_PRIM_TEX_CLAMP_MODE_T_WRAP=($00000000 shl 11);
 PRIM_TEX_CNTL_PRIM_TEX_CLAMP_MODE_T_MIRROR=($00000001 shl 11);
 PRIM_TEX_CNTL_PRIM_TEX_CLAMP_MODE_T_CLAMP=($00000002 shl 11);
 PRIM_TEX_CNTL_PRIM_TEX_CLAMP_MODE_T_BORDER_COLOR=($00000003 shl 11);
 PRIM_TEX_CNTL_PRIM_TEX_WRAP_T_OFF=($00000000 shl 13);
 PRIM_TEX_CNTL_PRIM_TEX_WRAP_T_ON=($00000001 shl 13);
 PRIM_TEX_CNTL_PRIM_TEX_PERSPECTIVE_DIS_OFF=($00000000 shl 14);
 PRIM_TEX_CNTL_PRIM_TEX_PERSPECTIVE_DIS_ON=($00000001 shl 14);
 PRIM_TEX_CNTL_PRIM_DATATYPE_VQ=($00000000 shl 16);
 PRIM_TEX_CNTL_PRIM_DATATYPE_CI4=($00000001 shl 16);
 PRIM_TEX_CNTL_PRIM_DATATYPE_CI8=($00000002 shl 16);
 PRIM_TEX_CNTL_PRIM_DATATYPE_ARGB1555=($00000003 shl 16);
 PRIM_TEX_CNTL_PRIM_DATATYPE_RGB565=($00000004 shl 16);
 PRIM_TEX_CNTL_PRIM_DATATYPE_RGB888=($00000005 shl 16);
 PRIM_TEX_CNTL_PRIM_DATATYPE_ARGB8888=($00000006 shl 16);
 PRIM_TEX_CNTL_PRIM_DATATYPE_RGB332=($00000007 shl 16);
 PRIM_TEX_CNTL_PRIM_DATATYPE_Y8=($00000008 shl 16);
 PRIM_TEX_CNTL_PRIM_DATATYPE_RGB8=($00000009 shl 16);
 PRIM_TEX_CNTL_PRIM_DATATYPE_CI16=($0000000a shl 16);
 PRIM_TEX_CNTL_PRIM_DATATYPE_YUV422=($0000000b shl 16);
 PRIM_TEX_CNTL_PRIM_DATATYPE_YUV422_2=($0000000c shl 16);
 PRIM_TEX_CNTL_PRIM_DATATYPE_AYUV444=($0000000d shl 16);
 PRIM_TEX_CNTL_PRIM_DATATYPE_ARGB4444=($0000000e shl 16);
{ PRIM_TEX_CNTL_PRIM_PALETTE_OFF_          }
{ PRIM_TEX_CNTL_PRIM_PSEUDOCOLOR_DATATYPE_ }

(* SETUP_CNTL bit constants *)
 SETUP_CNTL_DONT_START_TRI_OFF=($00000000 shl 0);
 SETUP_CNTL_DONT_START_TRI_ON=($00000001 shl 0);
 SETUP_CNTL_Z_BIAS=($00000000 shl 1);
 SETUP_CNTL_DONT_START_ANY_OFF=($00000000 shl 2);
 SETUP_CNTL_DONT_START_ANY_ON=($00000001 shl 2);
 SETUP_CNTL_COLOR_FNC_SOLID_COLOR=($00000000 shl 3);
 SETUP_CNTL_COLOR_FNC_FLAT_VERT_1=($00000001 shl 3);
 SETUP_CNTL_COLOR_FNC_FLAT_VERT_2=($00000002 shl 3);
 SETUP_CNTL_COLOR_FNC_FLAT_VERT_3=($00000003 shl 3);
 SETUP_CNTL_COLOR_FNC_GOURAUD=($00000004 shl 3);
 SETUP_CNTL_PRIM_TYPE_SELECT_TRI=($00000000 shl 7);
 SETUP_CNTL_PRIM_TYPE_SELECT_LINE=($00000001 shl 7);
 SETUP_CNTL_PRIM_TYPE_SELECT_POINT=($00000002 shl 7);
 SETUP_CNTL_PRIM_TYPE_SELECT_POLY_EDGE=($00000003 shl 7);
 SETUP_CNTL_TEXTURE_ST_FORMAT_MULT_W=($00000000 shl 9);
 SETUP_CNTL_TEXTURE_ST_FORMAT_DIRECT=($00000001 shl 9);
 SETUP_CNTL_STARTING_VERTEX_SELECT_1=($00000001 shl 14);
 SETUP_CNTL_STARTING_VERTEX_SELECT_2=($00000002 shl 14);
 SETUP_CNTL_STARTING_VERTEX_SELECT_3=($00000003 shl 14);
 SETUP_CNTL_ENDING_VERTEX_SELECT_1=($00000001 shl 16);
 SETUP_CNTL_ENDING_VERTEX_SELECT_2=($00000002 shl 16);
 SETUP_CNTL_ENDING_VERTEX_SELECT_3=($00000003 shl 16);
 SETUP_CNTL_SU_POLY_LINE_LAST=($00000000 shl 18);
 SETUP_CNTL_SU_POLY_LINE_NOT_LAST=($00000001 shl 18);
 SETUP_CNTL_SUB_PIX_AMOUNT_2BITS=($00000000 shl 19);
 SETUP_CNTL_SUB_PIX_AMOUNT_4BITS=($00000001 shl 19);
{ SETUP_CNTL_SU_POLY_EDGE        }
{ SETUP_CNTL_SU_EDGE_DST_Y_MAJOR }
{ SETUP_CNTL_SU_STATE            }
 SETUP_CNTL_SET_UP_CONTINUE=($00000001 shl 31);

(* PM4_VC_FPU_SETUP bit constants *)
 PM4_VC_FPU_SETUP_FRONT_DIR_CW=($00000000 shl 0);
 PM4_VC_FPU_SETUP_FRONT_DIR_CCW=($00000001 shl 0);
 PM4_VC_FPU_SETUP_BACKFACE_CULLING_FN_CULL=($00000000 shl 1);
 PM4_VC_FPU_SETUP_BACKFACE_CULLING_FN_POINT=($00000001 shl 1);
 PM4_VC_FPU_SETUP_BACKFACE_CULLING_FN_LINE=($00000002 shl 1);
 PM4_VC_FPU_SETUP_BACKFACE_CULLING_FN_REV_SOLID=($00000003 shl 1);
 PM4_VC_FPU_SETUP_FRONTFACE_CULLING_FN_CULL=($00000000 shl 3);
 PM4_VC_FPU_SETUP_FRONTFACE_CULLING_FN_POINT=($00000001 shl 3);
 PM4_VC_FPU_SETUP_FRONTFACE_CULLING_FN_LINE=($00000002 shl 3);
 PM4_VC_FPU_SETUP_FRONTFACE_CULLING_FN_REV_SOLID=($00000003 shl 3);
 PM4_VC_FPU_SETUP_PM4_COLOR_FCN_SOLID=($00000000 shl 5);
 PM4_VC_FPU_SETUP_PM4_COLOR_FCN_FLAT=($00000001 shl 5);
 PM4_VC_FPU_SETUP_PM4_COLOR_FCN_GOURAUD=($00000002 shl 5);
 PM4_VC_FPU_SETUP_PM4_COLOR_FCN_GOURAUD2=($00000003 shl 5);
 PM4_VC_FPU_SETUP_PM4_SUB_PIX_AMOUNT_2BITS=($00000000 shl 7);
 PM4_VC_FPU_SETUP_PM4_SUB_PIX_AMOUNT_4BITS=($00000001 shl 7);
 PM4_VC_FPU_SETUP_FPU_MODE_2D=($00000000 shl 8);
 PM4_VC_FPU_SETUP_FPU_MODE_3D=($00000001 shl 8);
 PM4_VC_FPU_SETUP_TRAP_DISABLE_OFF=($00000000 shl 9);
 PM4_VC_FPU_SETUP_TRAP_DISABLE_ON=($00000001 shl 9);
 PM4_VC_FPU_SETUP_EDGE_ANTIALIAS_OFF=($00000000 shl 10);
 PM4_VC_FPU_SETUP_EDGE_ANTIALIAS_ON=($00000001 shl 10);
 PM4_VC_FPU_SETUP_SUPERSAMPLE_OFF=($00000000 shl 11);
 PM4_VC_FPU_SETUP_SUPERSAMPLE_ON=($00000001 shl 11);
 PM4_VC_FPU_SETUP_XFACTOR_2=($00000000 shl 12);
 PM4_VC_FPU_SETUP_XFACTOR_4=($00000001 shl 12);
 PM4_VC_FPU_SETUP_YFACTOR_2=($00000000 shl 13);
 PM4_VC_FPU_SETUP_YFACTOR_4=($00000001 shl 13);
 PM4_VC_FPU_SETUP_FLAT_SHADE_VERTEX_D3D=($00000000 shl 14);
 PM4_VC_FPU_SETUP_FLAT_SHADE_VERTEX_OPENGL=($00000001 shl 14);
 PM4_VC_FPU_SETUP_FPU_ROUND_EN_OFF=($00000000 shl 15);
 PM4_VC_FPU_SETUP_FPU_ROUND_EN_ON=($00000001 shl 15);
 PM4_VC_FPU_SETUP_VC_WM_SEL_8DW=($00000000 shl 16);
 PM4_VC_FPU_SETUP_VC_WM_SEL_16DW=($00000001 shl 16);
 PM4_VC_FPU_SETUP_VC_WM_SEL_32DW=($00000002 shl 16);

(* SEC_TEX_CNTL bit constants *)
 SEC_TEX_CNTL_SEC_SRC_SEL_ST_0=($00000000 shl 0);
 SEC_TEX_CNTL_SEC_SRC_SEL_ST_1=($00000001 shl 0);

(* [PRIM_ | SEC_] SEC_TEX_COMBINE_CNTL bit constants *)
 TEX_COMBINE_CNTL_COMB_FNC_DIS=($00000000 shl 0);
 TEX_COMBINE_CNTL_COMB_FNC_COPY=($00000001 shl 0);
 TEX_COMBINE_CNTL_COMB_FNC_COPY_INP=($00000002 shl 0);
 TEX_COMBINE_CNTL_COMB_FNC_MODULATE=($00000003 shl 0);
 TEX_COMBINE_CNTL_COMB_FNC_MODULATE2X=($00000004 shl 0);
 TEX_COMBINE_CNTL_COMB_FNC_MODULATE4X=($00000005 shl 0);
 TEX_COMBINE_CNTL_COMB_FNC_ADD=($00000006 shl 0);
 TEX_COMBINE_CNTL_COMB_FNC_ADD_SIGNED=($00000007 shl 0);
 TEX_COMBINE_CNTL_COMB_FNC_BLEND_VERTEX=($00000008 shl 0);
 TEX_COMBINE_CNTL_COMB_FNC_BLEND_TEXTURE=($00000009 shl 0);
 TEX_COMBINE_CNTL_COMB_FNC_BLEND_CONST=($0000000a shl 0);
 TEX_COMBINE_CNTL_COMB_FNC_BLEND_PREMULT=($0000000b shl 0);
 TEX_COMBINE_CNTL_COMB_FNC_BLEND_PREV=($0000000c shl 0);
 TEX_COMBINE_CNTL_COMB_FNC_BLEND_PREMULT_INV=($0000000d shl 0);
 TEX_COMBINE_CNTL_COMB_FNC_ADD_SIGNED2X=($0000000e shl 0);
 TEX_COMBINE_CNTL_COMB_FNC_BLEND_CONST_COLOR=($0000000f shl 0);
 TEX_COMBINE_CNTL_COLOR_FACTOR_TEX=($00000004 shl 4);
 TEX_COMBINE_CNTL_COLOR_FACTOR_NTEX=($00000005 shl 4);
 TEX_COMBINE_CNTL_COLOR_FACTOR_ALPHA=($00000006 shl 4);
 TEX_COMBINE_CNTL_COLOR_FACTOR_NALPHA=($00000007 shl 4);
 TEX_COMBINE_CNTL_INPUT_FACTOR_CONST_COLOR=($00000002 shl 10);
 TEX_COMBINE_CNTL_INPUT_FACTOR_CONST_ALPHA=($00000003 shl 10);
 TEX_COMBINE_CNTL_INPUT_FACTOR_INT_COLOR=($00000004 shl 10);
 TEX_COMBINE_CNTL_INPUT_FACTOR_INT_ALPHA=($00000005 shl 10);
 TEX_COMBINE_CNTL_INPUT_FACTOR_PREV_COLOR=($00000008 shl 10);
 TEX_COMBINE_CNTL_INPUT_FACTOR_PREV_ALPHA=($00000009 shl 10);
 TEX_COMBINE_CNTL_COMB_FNC_ALPHA_DIS=($00000000 shl 14);
 TEX_COMBINE_CNTL_COMB_FNC_ALPHA_COPY=($00000001 shl 14);
 TEX_COMBINE_CNTL_COMB_FNC_ALPHA_COPY_INP=($00000002 shl 14);
 TEX_COMBINE_CNTL_COMB_FNC_ALPHA_MODULATE=($00000003 shl 14);
 TEX_COMBINE_CNTL_COMB_FNC_ALPHA_MODULATE2X=($00000004 shl 14);
 TEX_COMBINE_CNTL_COMB_FNC_ALPHA_MODULATE4X=($00000005 shl 14);
 TEX_COMBINE_CNTL_COMB_FNC_ALPHA_ADD=($00000006 shl 14);
 TEX_COMBINE_CNTL_COMB_FNC_ALPHA_ADD_SIGNED=($00000007 shl 14);
 TEX_COMBINE_CNTL_COMB_FNC_ALPHA_ADD_SIGNED2X=($0000000e shl 14);
 TEX_COMBINE_CNTL_ALPHA_FACTOR_TEX_ALPHA=($00000006 shl 18);
 TEX_COMBINE_CNTL_ALPHA_FACTOR_NTEX_ALPHA=($00000007 shl 18);
 TEX_COMBINE_CNTL_INP_FACTOR_ALPHA_CONST_ALPHA=($00000001 shl 25);
 TEX_COMBINE_CNTL_INP_FACTOR_ALPHA_INT_ALPHA=($00000002 shl 25);
 TEX_COMBINE_CNTL_INP_FACTOR_ALPHA_PREV_ALPHA=($00000004 shl 25);

(* SCALE_3D_CNTL bit constants *)
 SCALE_3D_CNTL_SCALE_DITHER_ERR_DIFF=($00000000 shl 1);
 SCALE_3D_CNTL_SCALE_DITHER_TABLE=($00000001 shl 1);
 SCALE_3D_CNTL_TEX_CACHE_SIZE_FULL=($00000000 shl 2);
 SCALE_3D_CNTL_TEX_CACHE_SIZE_HALF=($00000001 shl 2);
 SCALE_3D_CNTL_DITHER_INIT_CURR=($00000000 shl 3);
 SCALE_3D_CNTL_DITHER_INIT_RESET=($00000001 shl 3);
 SCALE_3D_CNTL_ROUND_EN_OFF=($00000000 shl 4);
 SCALE_3D_CNTL_ROUND_EN_ON=($00000001 shl 4);
 SCALE_3D_CNTL_TEX_CACHE_DIS_OFF=($00000000 shl 5);
 SCALE_3D_CNTL_TEX_CACHE_DIS_ON=($00000001 shl 5);
 SCALE_3D_CNTL_SCALE_3D_FN_NONE=($00000000 shl 6);
 SCALE_3D_CNTL_SCALE_3D_FN_SCALE=($00000001 shl 6);
 SCALE_3D_CNTL_SCALE_3D_FN_TMAP_SHADE=($00000002 shl 6);
 SCALE_3D_CNTL_SCALE_PIX_REP_BLEND=($00000000 shl 8);
 SCALE_3D_CNTL_SCALE_PIX_REP_REP=($00000001 shl 8);
 SCALE_3D_CNTL_TEX_CACHE_SPLIT_OFF=($00000000 shl 9);
 SCALE_3D_CNTL_TEX_CACHE_SPLIT_ON=($00000001 shl 9);
 SCALE_3D_CNTL_APPLE_YUV_MODE_OFF=($00000000 shl 10);
 SCALE_3D_CNTL_APPLE_YUV_MODE_ON=($00000001 shl 10);
 SCALE_3D_CNTL_TEX_CACHE_PAL_MODE_OFF=($00000000 shl 11);
 SCALE_3D_CNTL_TEX_CACHE_PAL_MODE_ON=($00000001 shl 11);
 SCALE_3D_CNTL_ALPHA_COMB_FNC_ADD_CLAMP=($00000000 shl 12);
 SCALE_3D_CNTL_ALPHA_COMB_FNC_ADD_NCLAMP=($00000001 shl 12);
 SCALE_3D_CNTL_ALPHA_COMB_FNC_SUB_DST_SRC_CLAMP=($00000002 shl 12);
 SCALE_3D_CNTL_ALPHA_COMB_FNC_SUB_DST_SRC_NCLAMP=($00000003 shl 12);
 SCALE_3D_CNTL_FOG_TABLE_EN_OFF=($00000000 shl 14);
 SCALE_3D_CNTL_FOG_TABLE_EN_ON=($00000001 shl 14);
 SCALE_3D_CNTL_SIGNED_DST_CLAMP_OFF=($00000000 shl 15);
 SCALE_3D_CNTL_SIGNED_DST_CLAMP_ON=($00000001 shl 15);
 SCALE_3D_CNTL_ALPHA_BLEND_SRC_ZERO=($00000000 shl 16);
 SCALE_3D_CNTL_ALPHA_BLEND_SRC_ONE=($00000001 shl 16);
 SCALE_3D_CNTL_ALPHA_BLEND_SRC_SRCCOLOR=($00000002 shl 16);
 SCALE_3D_CNTL_ALPHA_BLEND_SRC_INVSRCCOLOR=($00000003 shl 16);
 SCALE_3D_CNTL_ALPHA_BLEND_SRC_SRCALPHA=($00000004 shl 16);
 SCALE_3D_CNTL_ALPHA_BLEND_SRC_INVSRCALPHA=($00000005 shl 16);
 SCALE_3D_CNTL_ALPHA_BLEND_SRC_DSTALPHA=($00000006 shl 16);
 SCALE_3D_CNTL_ALPHA_BLEND_SRC_INVDSTALPHA=($00000007 shl 16);
 SCALE_3D_CNTL_ALPHA_BLEND_SRC_DSTCOLOR=($00000008 shl 16);
 SCALE_3D_CNTL_ALPHA_BLEND_SRC_INVDSTCOLOR=($00000009 shl 16);
 SCALE_3D_CNTL_ALPHA_BLEND_SRC_SAT=($0000000a shl 16);
 SCALE_3D_CNTL_ALPHA_BLEND_SRC_BLEND=($0000000b shl 16);
 SCALE_3D_CNTL_ALPHA_BLEND_SRC_INVBLEND=($0000000c shl 16);
 SCALE_3D_CNTL_ALPHA_BLEND_DST_ZERO=($00000000 shl 20);
 SCALE_3D_CNTL_ALPHA_BLEND_DST_ONE=($00000001 shl 20);
 SCALE_3D_CNTL_ALPHA_BLEND_DST_SRCCOLOR=($00000002 shl 20);
 SCALE_3D_CNTL_ALPHA_BLEND_DST_INVSRCCOLOR=($00000003 shl 20);
 SCALE_3D_CNTL_ALPHA_BLEND_DST_SRCALPHA=($00000004 shl 20);
 SCALE_3D_CNTL_ALPHA_BLEND_DST_INVSRCALPHA=($00000005 shl 20);
 SCALE_3D_CNTL_ALPHA_BLEND_DST_DSTALPHA=($00000006 shl 20);
 SCALE_3D_CNTL_ALPHA_BLEND_DST_INVDSTALPHA=($00000007 shl 20);
 SCALE_3D_CNTL_ALPHA_BLEND_DST_DSTCOLOR=($00000008 shl 20);
 SCALE_3D_CNTL_ALPHA_BLEND_DST_INVDSTCOLOR=($00000009 shl 20);
 SCALE_3D_CNTL_ALPHA_TEST_OP_NEVER=($00000000 shl 24);
 SCALE_3D_CNTL_ALPHA_TEST_OP_LESS=($00000001 shl 24);
 SCALE_3D_CNTL_ALPHA_TEST_OP_LESSEQUAL=($00000002 shl 24);
 SCALE_3D_CNTL_ALPHA_TEST_OP_EQUAL=($00000003 shl 24);
 SCALE_3D_CNTL_ALPHA_TEST_OP_GREATEREQUAL=($00000004 shl 24);
 SCALE_3D_CNTL_ALPHA_TEST_OP_GREATER=($00000005 shl 24);
 SCALE_3D_CNTL_ALPHA_TEST_OP_NEQUAL=($00000006 shl 24);
 SCALE_3D_CNTL_ALPHA_TEST_OP_ALWAYS=($00000007 shl 24);
 SCALE_3D_CNTL_COMPOSITE_SHADOW_CMP_EQUAL=($00000000 shl 28);
 SCALE_3D_CNTL_COMPOSITE_SHADOW_CMP_NEQUAL=($00000001 shl 28);
 SCALE_3D_CNTL_COMPOSITE_SHADOW_EN_OFF=($00000000 shl 29);
 SCALE_3D_CNTL_COMPOSITE_SHADOW_EN_ON=($00000001 shl 29);
 SCALE_3D_CNTL_TEX_MAP_AEN_OFF=($00000000 shl 30);
 SCALE_3D_CNTL_TEX_MAP_AEN_ON=($00000001 shl 30);
 SCALE_3D_CNTL_TEX_CACHE_LINE_SIZE_8QW=($00000000 shl 31);
 SCALE_3D_CNTL_TEX_CACHE_LINE_SIZE_4QW=($00000001 shl 31);

Implementation

end.