Unit TARGA;

Interface

uses
 FLAT,R128;

Var
 Rect:packed record
  Left,Top,Width,Height:word;
 end;

procedure Load(x,y:longint; FileName:string);

Implementation

Type
 THeader=packed record
  len   :byte; { File Header len }
  colmap:byte; { Color Map = 1   }
  flag  :byte; { File type       }
  col1  :word; { First Color }
  cols  :word; { Color count }
  bpc   :byte;
  Left  :word;
  Top   :word;
  width :word;
  height:word;
  bpp   :byte;
  coord :byte; { 0 - bottom left  }
               { 1 - bottom right }
               { 2 - top left     }
               { 3 - top right    }

 end;

procedure Load(x,y:longint; FileName:string);
 var
  f:file;
  h:THeader;
  l:longint;
  p:pointer;
  s:longint;
  i:integer;
  d:longint;
  w:word;
  c:array[0..255] of longint;
 begin
  assign(f,FileName);
  reset(f,1);
  if ioResult<>0 then begin
   TextMode;
   writeln(#7'file not found');
   exit;
  end;
  BlockRead(f,h,SizeOf(h));

  if odd(h.coord)
  and((h.colmap<>1)or(h.flag<>1)or(h.bpp<>8))
  and((h.colmap<>0)or(h.flag<>2)or(h.bpp=8)or(h.bpp=16)) then begin

   TextMode;
   writeln(#7'Unsupported TARGA file');

  end else begin

   if h.bpp=8 then {seek(f,sizeof(h)+3*h.cols);}
    BlockRead(f,c[h.col1],3*h.cols);

   l:=h.width*((h.bpp+1) div 8);

   getmem(p,l);
   s:=FlatPtr(p);

   w:=BytesPerLine;
   d:=BaseMemory+w*y+BytesPerPixel*x;

   for i:=1 to h.height do begin

    blockread(f,p^,l);

    if ioresult<>0 then begin
     textmode;
     writeln(#7,'Read error on line ',i,'/',h.Height);
     break;
    end;

    move32(s,d,l);

    inc(d,w);
   end;
   freemem(p,l);

   move(h.Left,Rect,SizeOf(Rect));

  end;

  close(f);
 end;

end.